//manage TX/RX/IPSource list
//supporting websocket
if (!window.WebSocket)
{
    alert("WebSocket not supported by this browser!");
}

document.onmousewheel = function() { if(event.ctrlKey) return false; }

var normalcolor = "#f0f0f0";
var highlightcolor = "#5bff23"; // "#00ff00";
var defaultcolor = "#c0c0c0";
var unicastcolor = "#5baa23";
var otherscenecolor = "#505050"; // "#232323";

function updateDevices()
{
    // var searching_img = document.getElementById('searching_img');
    // searching_img.style.display = "";
    showLoader("searching device...");

    if (ws)
    {
        var cmd = "update get devices;config get ipsources;"; // var cmd = "config get devices;config get ipsources;";

        ws.doSend(cmd);
        console.log(cmd);
    }    
}

function handleData_Channel(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];
   
    var ack = JSON.parse(data);

    if (ack && ack.devinfo)
    {
    	var i       = 0;
    	var j       = 0;
        var k       = 0;

        //buildSearch();

    	for (var dev in ack.devinfo)
    	{
    		var device = ack.devinfo[k++];
    	
    	    if (device.devtype == "encoder")
    	    {
    	    	//device.id, device.channel, device.url
    	    	addTX(i, device.devaddr, i, 2, device.devname);
	            //console.log("channel.js: " + "addTX");    	    	
    	    	i ++;			
    	    }
            else if (device.devtype == "decoder")
            {
                // addRX(j, device.devaddr, 5, device.devname);
                addRX(j, device.devaddr, device.devsplitnum, device.devname);
                //console.log("channel.js: " + "addRX");              
                j ++;
            }
    	}

        buildRX();
        buildTX();
        //console.log("channel.js: " + "buildTX");
    }
    else if (ack && ack.ipsourcedev)
    {
    	var i       = 0;
    	var j       = 0;

    	//console.log("ack.ipsourcedev");
    	for (var dev in ack.ipsourcedev)
    	{
    		var ipsource = ack.ipsourcedev[j++];
   	
	    	//device.id, device.channel, device.url
	    	addIPSource(i, ipsource.devaddr, i, 1, ipsource.devname);
            //console.log("channel.js: " + "addIPSource" + ipsource.devaddr);
	    	i ++;

    		//console.log("ipsourcedev: " + ipsource.devaddr);
    	}

		buildIPSource();
    }
};

function initChannelsUI() {
	/* loadChannel */
	console.log("loadChannel");

   // buildSearch();
}

function buildSearch() {

    showLoader("searching device...");
    //alert("searching!");
    // var searching = document.getElementById('searching');

    // var str = "";
    // str +='<input type="button" style="font-size:10px;margin-left:0px;margin-right:10px;" value="Search" id="update1" class="button ui-widget-content ui-corner-all" onclick="javascript:updateDevices();" />';
    // str += '<img src="images/searching.gif" id="searching_img" style="width:50%; height:50%;margin-top:4px; display:none" />';

    // searching.innerHTML = str;
}

window.onresize = function() {
    socketOpened();
}

function setmessagehandler() {
    var messageHandle = function(e) {
        val = GetMessageString(e.data, "winmode");
        if (val.length > 0)
        {
            document.location.href = "channel.html";
        }

        val = GetMessageString(e.data, "usermode");
        if (val.length > 0)
        {
            document.location.href = "channel.html";
        }
    };
    
    if (window.addEventListener) {
        window.addEventListener("message", messageHandle, false);
        //alert("addEvent");
    } else if (window.attachEvent) {

        window.attachEvent('onmessage', messageHandle);
        //alert("attachEvent");
    }    
}


var arrayRX = new Array();
var addRX = function (index, ip, splitm, name) {

    arrayRX.push(index + "," + ip + "," + splitm + "," + name);
};

var arrayTX = new Array();
var addTX = function (index, ip, id, channel, name) {

    arrayTX.push(index + "," + ip + "," + id + "," + channel + "," + name);
};

var arrayIPSource = new Array();
var addIPSource = function (index, ip, id, channel, url) {

    arrayIPSource.push(index + "," + ip + "," + id + "," + channel + "," + url);
};

function addRXItem(tbody, id, ip, name, splitm) {
    var tr = document.createElement('tr');

    var color1, color4, color5;
    var size;
    var margin;

    var modelcheck = document.getElementById('model_version_info').innerHTML;
		
    if (splitm == 5)
    {
        color1 = normalcolor;
        color4 = normalcolor;
        color5 = highlightcolor;
        if(getUniScrIDbyIP(ip) != -1) {
            color5 = unicastcolor;
        }
        if (getOtherSceneScrIDbyIP(ip) > -1) {
            color5 = otherscenecolor;
        }		
    }
    else if (splitm == 4)
    {
        color1 = normalcolor;
        color4 = highlightcolor;
        if(getUniScrIDbyIP(ip) != -1) {
            color4 = unicastcolor;
        }
        if (getOtherSceneScrIDbyIP(ip) > -1) {
            color4 = otherscenecolor;
        }
        color5 = normalcolor;
    }
    else
    {
        color1 = highlightcolor;
        if(getUniScrIDbyIP(ip) != -1) {
            color1 = unicastcolor;
        }
        if (getOtherSceneScrIDbyIP(ip) > -1) {
            color1 = otherscenecolor;
        }
        color4 = normalcolor;
        color5 = normalcolor;           
    }

    size = "8px";
    margin = "0px";

    var str  = "<td class='td1' id='rxname" + id + "'>"; //<i>" + name + "</i>";
        str += "<i></i><a>";
        if(modelcheck == "EXT-NETAVKIT") {
            str += "<span id='rxName" + id + "'>" + name + "</span>";
        }
        else {
            str += "<span id='rxName" + id + "' onclick='rxSpanEvent(" + id;
            str += ",";
            str += " \"";
            str += ip;
            str += "\");";
            str += "' >" + name + "</span>";
        }

        str += "</a></td>";
        str += "<td class='td2' ><a href='#" + ip + "' id='rx" + id + "'>" + ip + "</a></td>";
        // str += "<td class='td3'></td>";

    if (usermode == 1) //unicast
    {
        //if rx inside video wall, diable
        if ((getVWScrIDbyIP(ip) != -1) || ((getOtherSceneScrIDbyIP(ip) != -1))) // inside wall or scene wall
        {
            //video wall use it, disable!
            str += "<td class='td3'>";    
            str += "    <input type='button' id='btn1x" + id + "' value='1x' style='background: defaultcolor;'"; // #808080;'";
            str += ' ">';
            str += "</td>";
            str += "<td class='td3'>";
            str += "    <input type='button' id='btn4x" + id + "' value='4x' style='background: defaultcolor;'"; // #808080;'";
            str += ' ">';
            str += "</td>";
            str += "<td class='td3'>"
            str += "    <input type='button' id='btn5x" + id + "' value='5x' style='background: defaultcolor;'"; // #808080;'";
            str += ' ">';
            str += "</td>";
            str += "<td class='td3'></td>";

            tr.innerHTML = str;

            tbody.appendChild(tr);

            return;
        }
    }
    else if (usermode == 2) //mulcast
    {
        //all rx disable
        str += "<td class='td3'>";    
        str += "    <input type='button' id='btn1x" + id + "' value='1x' style='background: defaultcolor;'"; // #808080;'";
        str += ' ">';
        str += "</td>";
        str += "<td class='td3'>";
        str += "    <input type='button' id='btn4x" + id + "' value='4x' style='background: defaultcolor;'"; // #808080;'";
        str += ' ">';
        str += "</td>";
        str += "<td class='td3'>"
        str += "    <input type='button' id='btn5x" + id + "' value='5x' style='background: defaultcolor;'"; // #808080;'";
        str += ' ">';
        str += "</td>";
        str += "<td class='td3'></td>";

        tr.innerHTML = str;

        tbody.appendChild(tr);

        return;
    }

    str += "<td class='td3'>";    
    str += "    <input type='button' id='btn1x" + id + "' value='1x' style='background:" + color1 + ";'";
    str += ' onclick="javascript: create1x(';
    str += id;
    str += ",";
    str += '\'';
    str += ip;
    str += '\'';
    str += ');">';
    str += "</td>";
    str += "<td class='td3'>";
    str += "    <input type='button' id='btn4x" + id + "' value='4x' style='background:" + color4 + ";'";
    str += ' onclick="javascript: create4x(';
    str += id;
    str += ",";
    str += '\'';
    str += ip;
    str += '\'';
    str += ');">';
    str += "</td>";
    str += "<td class='td3'>"
    str += "    <input type='button' id='btn5x" + id + "' value='5x' style='background:" + color5 + ";'";
    str += ' onclick="javascript: create5x(';
    str += id;
    str += ",";
    str += '\'';
    str += ip;
    str += '\'';
    str += ');">';
    str += "</td>";
    str += "<td class='td3'></td>";	

    tr.innerHTML = str;

    tbody.appendChild(tr);
}

function addTXItem(tbody, id, ip, name) {
    var tr = document.createElement('tr');
    var modelcheck = document.getElementById('model_version_info').innerHTML;

    var str  = "<td class='td1' id='txname" + id + "'>"; //<i>" + name + "</i>";
        str += "<i></i><a>";
        if(modelcheck == "EXT-NETAVKIT") {
            str += "<span id='txName" + id + "' >" + name + "</span>";
        }
        else {
            str += "<span id='txName" + id + "' onclick='txSpanEvent(";
            str += id;
            str += ",";
            str += '\"';
            str += ip;
            str += '\"';
            str += ");";
            str += "' >" + name + "</span>";
        }
        str += "</a></td>";
        str += "<td class='td2' ><a href='#" + ip + "' id='tx" + id + "'>" + ip + "</a></td><td class='td2'></td><td class='td3'></td>";

    tr.innerHTML = str;

    tbody.appendChild(tr);
}

function addIPItem(tbody, id, ip, name) {
    var tr = document.createElement('tr');
    var modelcheck = document.getElementById('model_version_info').innerHTML;

    var str  = "<td class='td1' id='ipname" + id + "'>"; //<i>" + name + "</i>";
        str += "<i></i><a>";
        if(modelcheck == "EXT-NETAVKIT") {
            str += "<span id='ipName" + id + "' >" + name + "</span>";
        }
        else {
            str += "<span id='ipName" + id + "' onclick='ipSpanEvent(";
            str += id;
            str += ",";
            str += '\"';
            str += ip;
            str += '\"';
            str += ");";
            str += "' >" + name + "</span>";
        }
        str += "</a></td>";
        str += "<td class='td2'><a href='#" + ip + "' id='ip" + id + "'>" + ip + "</a></td><td class='td2'></td><td class='td3'></td>";

    tr.innerHTML = str;

    tbody.appendChild(tr);
}

var rtotal = 0;
function buildRX() {
	//console.log("buildRX");

    //clean RX
    var rxbody = document.getElementById('rxbody');
    rxbody.innerHTML = "";

    var first;
    var rindex = 0;
    var rcount = arrayRX.length;
    
    rtotal = 0;

    do {
    	first = arrayRX.shift();

    	if (first != null)
    	{
    		var vals = first.split(",");
    		//console.log(parseInt(vals[0]) * 2 + 1);

            var id = rindex + 1;
    		//d.add(id /* index */, 0, vals[1] /* ip */, '#', id + " " + vals[2] /* splitm */ + " " + vals[3]);

            /* id, ip, splitm, name */
            addRXItem(rxbody, id, vals[1], vals[3], vals[2]);    //addRXItem(tbody, id, ip, name, splitm)

    		rindex ++;
    		rtotal ++;    		
    	}
    }
    while (first != null);

    //id must be started from 1
    for (var i = 1; i < rtotal + 1; i ++)
    {
    	//use '#', id will be sd1, sd2, sd3...
	var oDiv = document.getElementById("rx" + i);  
        oDiv.onclick = function (e) {
            if (usermode == 1) //unicast mode
            {
                //support click to select item
                var ip = this.innerHTML;
                //alert(this.innerHTML);
                var id = parseInt(this.id.split("x")[1]) - 1;

                if ((getVWScrIDbyIP(ip) == -1) && ((getOtherSceneScrIDbyIP(ip) == -1))) // not inside wall and not inside scene wall
                {
                    setScrID(0, ip);
                    dragRXIPOver(0, ip); // dragRXOver(0, id);
                }
            }
        }

        oDiv.ondrag = function (e) {
            console.log("ondrag!");
            // this.style.color= "#ff0000"; 
        }

        oDiv.ondragend = function (e) {
            e.preventDefault();
            console.log("ondragend!");
            // this.style.color = "#000000";  

            //window.html is 2 of frameset
            var x = e.pageX || (e.clientX + document.documentElement.scrollLeft || document.body.scrollLeft);//parseInt(e.screenX);
            var y = e.pageY || (e.clientY + document.documentElement.scrollTop || document.body.scrollTop);//parseInt(e.screenY);

            var ip = this.innerHTML;
            //alert(this.innerHTML);
            var id = parseInt(this.id.split("x")[1]) - 1;

            var vsx = x - ScrLeft;
            var vsy = y - ScrTop;
            var vsw = ScrWidth;
            var vsh = ScrHeight;
            var scrid = 0;

            if (usermode == 0) //video wall
            {
                if ((getOtherSceneScrIDbyIP(ip) == -1)) // not inside other scene wall
                {
                    for (var row = 0; row < vline; row ++)
                    {
                        for (var col = 0; col < vcolumn; col ++)
                        {
                            if (vsx > col * (vsw / vcolumn) &&
                                vsx < (col + 1) * (vsw / vcolumn) &&
                                vsy > row * (vsh / vline) &&
                                vsy < (row + 1) * (vsh / vline))
                            {
                                scrid = row * vcolumn + col;
                                setScrID(scrid, ip); //set ip to screen in UI
                                dragRXIPOver(scrid, ip); // dragRXOver(scrid, id); //tell windows.js which screen id
                                //alert(scrid + " " + id);
                                break;
                            }
                        }
                    }
                }
            }
            else
            {
                if ((getVWScrIDbyIP(ip) == -1) && ((getOtherSceneScrIDbyIP(ip) == -1))) // not inside wall and not inside scene wall
                {
                    setScrID(0, ip);
                    dragRXIPOver(0, ip); // dragRXOver(0, id);
                }
            }
        }

	    oDiv.ondragstart = function (e) {
            var dt = e.dataTransfer;
            //dt.effectAllowed = 'move';
            dt.effectAllowed = 'move';
            //dt.setDragImage(this, 0, 0);
	    }
	}

    //check RX valid
    if (usermode == 0) //video wall
    {
        //video wall, disable parts RX
        for (var i = 1; i < rtotal + 1; i ++)
        {
            var rx = document.getElementById("rx" + i);
            var ip = rx.innerHTML;
			
            if ((getOtherSceneScrIDbyIP(ip) != -1)) // inside other scene wall
            {
                rx.ondragstart = function (e) {
                    //do nothing
                    e.preventDefault();
                }

                rx.href = "javascript:void(0);";
                rx.style = "cursor:default";
                rx.disabled = true;
            }
        }
    }
    else if (usermode == 1) //unicast
    {
        //unicast, disable parts RX
        for (var i = 1; i < rtotal + 1; i ++)
        {
            var rx = document.getElementById("rx" + i);
            var ip = rx.innerHTML;

            if ((getVWScrIDbyIP(ip) != -1) || ((getOtherSceneScrIDbyIP(ip) != -1))) // inside wall or inside scene wall   if (getVWScrIDbyIP(ip) != -1)
            {
                rx.ondragstart = function (e) {
                    //do nothing
                    e.preventDefault();
                }

                rx.href = "javascript:void(0);";
                rx.style = "cursor:default";
                rx.disabled = true;
            }
        }
    }
    else
    {
        //multicast, disable all RX
        for (var i = 1; i < rtotal + 1; i ++)
        {
            var rx = document.getElementById("rx" + i);
            rx.ondragstart = function (e) {
                //do nothing
                e.preventDefault();
            }

            rx.href = "javascript:void(0);";
            rx.style = "cursor:default";
            rx.disabled = true;
        }
    }    

    setmessagehandler();
}

var dtotal = 0;
function buildTX() {
	//console.log("buildTX");

    //clean tx
    var txbody = document.getElementById('txbody');
    txbody.innerHTML = "";

    var first;
    var dindex = 0;
    var dcount = arrayTX.length;
    
    dtotal = 0;

    do {
    	first = arrayTX.shift();

    	if (first != null)
    	{
    		var vals = first.split(",");

    		var channel = parseInt(vals[3]);

            var id = dindex + 1;
            addTXItem(txbody, id, vals[1], vals[4]);

    		dindex ++;
    		dtotal ++;    		
    	}
    }
    while (first != null);
    
    for (var i = 1; i < dtotal + 1; i ++)
    {
    	//use '#', id will be sd1, sd2, sd3...
	    var oDiv = document.getElementById("tx" + i);  

        oDiv.ondrag = function (e) {
            //e.preventDefault();
        	// console.log("ondrag!");
        	this.style.color= "#ff0000";     	
        }

	    oDiv.ondragend = function (e) {
            //e.preventDefault();
	    	console.log("ondragend!");
	    	this.style.color = "#000000";

            var id = parseInt(this.id.split("x")[1]) - 1;

            cursourcetype = "esource";
            cursource = id;
            cursourceip = this.innerHTML;
            curchannel = 0;       
	    }

	    oDiv.ondragstart = function (e) {
            //e.preventDefault();

            var dt = e.dataTransfer;
            //dt.effectAllowed = 'move';
            dt.effectAllowed = 'move';
            //dt.setDragImage(this, 0, 0);
	    }
	}

    setmessagehandler();
}

var stotal = 0;
function buildIPSource() {
	//console.log("buildIPSource");

    //clean stream
    var ipbody = document.getElementById('ipbody');
    ipbody.innerHTML = "";

    var first;
    var sindex = 0;
    var scount = arrayIPSource.length;
    stotal = 0;

    do {
    	first = arrayIPSource.shift();

    	if (first != null)
    	{
    	    var vals = first.split(",");
    	    //console.log(parseInt(vals[0]) * 2 + 1);

            var id = sindex + 1;
    	    //s.add(id, 0, vals[1], '#', vals[2] + " " + 0 + " " + vals[1] + " " + vals[4]);
            addIPItem(ipbody, id, vals[1], vals[4]); //

    		sindex ++;
    		stotal ++;    		
    	}
    }
    while (first != null);

    //id must be started from 1
    for (var j = 1; j < stotal + 1; j ++)
    {
    	//use '#', id will be sd1, sd2, sd3...
	    var oDiv = document.getElementById("ip" + j);  

        oDiv.ondrag = function (e) {
        	console.log("ondrag!");

        	//this.inerHTML = '<strong> test </strong>';
        	this.style.color= "#ff0000";
        }

	    oDiv.ondragend = function (e) {
            e.preventDefault();
	    	console.log("ondragend!");

	    	this.style.color = "#000000";

            var id = parseInt(this.id.split("p")[1]) - 1;

            cursourcetype = "isource";
            cursource = id;
            cursourceip = this.innerHTML;
            curchannel = 0;       

	    }

	    oDiv.ondragstart = function (e) {
	        //e.preventDefault();

	        console.log("ondragstart!");

            var dt = e.dataTransfer;
            dt.effectAllowed = 'move';

	    }
	}

    setmessagehandler();
}

function create1x(index, ip)
{
    var flag = checkScrAvailablebyIP(ip);

    if (flag)
    {
        var btn1 = document.getElementById('btn1x' + index);
        var btn4 = document.getElementById('btn4x' + index);
        var btn5 = document.getElementById('btn5x' + index);

        btn1.style.background = highlightcolor;
        btn4.style.background = normalcolor;
        btn5.style.background = normalcolor;
        //alert(id);
        if (usermode == 0)
        {
            var id = getVWScrIDbyIP(ip);
            createvwwin(id, 1, 1);
        }
        else {
            if(getUniScrIDbyIP(ip) != -1) {
                btn1.style.background = unicastcolor;
            }
            createuniwin(1, 1);
        }

        // complete_message("Create Windows Done!");
    }
}

function create4x(index,ip)
{
    var flag = checkScrAvailablebyIP(ip);

    if (flag)
    {
        var btn1 = document.getElementById('btn1x' + index);
        var btn4 = document.getElementById('btn4x' + index);
        var btn5 = document.getElementById('btn5x' + index);

        btn1.style.background = normalcolor;
        btn4.style.background = highlightcolor;
        btn5.style.background = normalcolor;

        if (usermode == 0)
        {
            var id = getVWScrIDbyIP(ip);
            createvwwin(id, 4, 1);
        }
        else {
            if(getUniScrIDbyIP(ip) != -1) {
                btn4.style.background = unicastcolor;
            }
            createuniwin(4, 1);
        }

        // complete_message("Create Windows Done!");
    }
}

function create5x(index,ip)
{
    var flag = checkScrAvailablebyIP(ip);

    if (flag)
    {
        var btn1 = document.getElementById('btn1x' + index);
        var btn4 = document.getElementById('btn4x' + index);
        var btn5 = document.getElementById('btn5x' + index);

        btn1.style.background = normalcolor;
        btn4.style.background = normalcolor;
        btn5.style.background = highlightcolor;

        if (usermode == 0)
        {
            var id = getVWScrIDbyIP(ip);
            createvwwin(id, 5, 1);
        }
        else {
            if(getUniScrIDbyIP(ip) != -1) {
                btn5.style.background = unicastcolor;
            }
            createuniwin(5, 1);
        }

        // complete_message("Create Windows Done!");
    }
}

function radiocheck(index)
{
    alert(index);
}

function rxSpanEvent(index, ip) {/* edit control! */
    console.log("rxSpanEvent");
    var rxName = document.getElementById('rxName' + index);
    var value = rxName.innerHTML;

    var a = rxName.parentNode;
    a.removeChild(rxName);

    a.innerHTML = "<input type='text' id='rxName" + index + "' maxlength='8' />";

    var input = document.getElementById('rxName' + index);
    input.value = value;
    input.focus();

    input.onkeyup = function() {
        if (event.keyCode == 13)
        {
            this.blur();  
        }
    }

    input.onblur = function() {/* remove control when focus lost! */

        if (input.value == "")
        {
            alert("Invalid Name!");
            input.value = value;

            return;
        }

        var span = document.createElement('span');
        a.innerHTML = "<span id='rxName" + index + "' onclick='javascript:rxSpanEvent(" + index + ", \"" + ip + "\");'>" + input.value + "</span>"; 

        if (input.value != value) {
            var cmd = "config set decoder name ";
                cmd += ip;
                cmd += " ";
                cmd += input.value; 

            //send cmd to server
            if (ws)
            {
                document.getElementById('rxName' + index).focus();
                if (usermode == 0)
                {
                    cmd +=  ";config get vs all params";
                }
                else if (usermode == 1)
                {
                    cmd +=  ";config get unicast all params";
                }
                else 
                {
                    cmd +=  ";config get multicast win params";
                }
                ws.doSend(cmd);
                console.log(cmd);
            }

            setuprxnamesync();            
        }
    }
}

function txSpanEvent(index, ip) {/* edit control! */

	console.log("txSpanEvent");
    var txName = document.getElementById('txName' + index);
	var value = txName.innerHTML;

	var a = txName.parentNode;
	a.removeChild(txName);

	a.innerHTML = "<input type='text' id='txName" + index + "' maxlength='8' />";

    var input = document.getElementById('txName' + index);
    input.value = value;
	input.focus();

    input.onkeyup = function() {
        if (event.keyCode == 13)
        {
            this.blur();        
        }
    }

	input.onblur = function() {/* remove control when focus lost! */
        if (input.value == "")
        {
            alert("Invalid Name!");
            input.value = value;

            return;
        }

	var span = document.createElement('span');
        a.innerHTML = "<span id='txName" + index + "' onclick='javascript:txSpanEvent(" + index + ", \"" + ip + "\");'>" + input.value + "</span>"; 

		//alert(a.innerHTML);

		if (input.value != value) {
		    var cmd = "config set encoder name ";
                cmd += ip;
                cmd += " ";
                cmd += input.value; 

            //send cmd to server
            if (ws)
            {
                document.getElementById('txName' + index).focus();
                if (usermode == 0)
                {
                    cmd +=  ";config get vs all params";
                }
                else if (usermode == 1)
                {
                    cmd +=  ";config get unicast all params";
                }
                else 
                {
                    cmd +=  ";config get multicast win params";
                }
            	ws.doSend(cmd);
            	console.log(cmd);
            }

            setuptxnamesync();
		}
	}
}

function ipSpanEvent(index, ip) {/* edit control! */

	console.log("ipSpanEvent");
    var ipName = document.getElementById('ipName' + index);
	var value = ipName.innerHTML;

	var a = ipName.parentNode;
	a.removeChild(ipName);

	a.innerHTML = "<input type='text' id='ipName" + index + "' maxlength='8' />";

    var input = document.getElementById('ipName' + index);
    input.value = value;
	input.focus();

    input.onkeyup = function() {
        if (event.keyCode == 13)
        {
            this.blur();        
        }
    }

    input.onblur = function() {/* remove control when focus lost! */
        if (input.value == "")
        {
            alert("Invalid Name!");
            input.value = value;

            return;
        }

        var span = document.createElement('span');
        a.innerHTML = "<span id='ipName" + index + "' onclick='javascript:ipSpanEvent(" + index + ", \"" + ip + "\");'>" + input.value + "</span>"; 

		if (input.value != value) {
		    var cmd = "config set ipsource name ";
                cmd += ip;
                cmd += " ";
                cmd += input.value; 

            //send cmd to server
            if (ws)
            {
                document.getElementById('ipName' + index).focus();
                cmd +=  ";config get vs all params;";
                cmd +=  "config get unicast all params;";
            	ws.doSend(cmd);
            	console.log(cmd);
            }

            setupipnamesync();
		}
	}
}


function close() {
    $(".cover").hide();
    $("#yes-input").off("click");
    $("#no-input").off("click");
    $(".cover").off("click");
}

function showLoader(text) {

    close();
    $("#loader-panel").show();
    $("#loader-panel p").text(text || "");
}
