//communication.js

if (!window.WebSocket) {
	alert("WebSocket not supported by this browser!");
}

//web socket
var ws;
var socketState = -1;
function setupSocket() {

    var hostip = document.location.host;
    var wsline;

    if (hostip.length != 0) {
    	var host = document.location.host.split(":");
        wsline = "ws://" + host[0] + ":9008";
    }
    else {
    	  wsline = "ws://localhost:9008";
    }

	if ('WebSocket' in window) {
        ws = new WebSocket(wsline);
        socketState = 0;		
    }
    else if ('MozWebSocket' in window) {
    	ws = new MozWebSocket(wsline);
        socketState = 0;		
    }
    else {
        alert("Not support websocket!");
        console.log("Not support websocket!");
    }
            
    //on message
    ws.onmessage = function(event) { 
        handleData(event.data);      
    }; 

    //close WebSocket 
    ws.onclose = function(event) { 
      //WebSocket Status:: Socket Closed
      // alert("WebSocket is onclose Fang!");
      socketState = 2;
    };
    
    //on error
    ws.onerror = function(event) {
    	//WebSocket Status:: Socket Error
        // alert("WebSocket is onerror Fang!");
        socketState = 3;
    };
     
    //open WebSocket
    ws.onopen = function(event) { 
        //WebSocket Status:: Socket Open       
        // alert("WebSocket is onopen Fang!");	
        socketState = 0;		
	    socketOpened();
    }; 
    
    ws.doSend = function(message) { 
        //WebSocket Status:: Socket Open     
        // alert("WebSocket is onopen Fang!");	
        if(socketState == 0)
        {
            ws.send(message);
        }
        else
        {
            // alert("socketState is not zero");
            document.location.href = "index.html";
            // console.log("redirect to index.html!");
        }
    }; 
}