//setup.js
//

var Console = {};

Console.log = (function(message) {
    var console = document.getElementById('console');
    var p = document.createElement('p');

    p.style.wordWrap = 'break-word';
    p.innerHTML = getTime() + "&nbsp;&nbsp;&nbsp;" + message;

    console.appendChild(p);

    while (console.childNodes.length > 20) {
        console.removeChild(console.firstChild);
    }

    console.scrollTop = console.scrollHeight;
});

function createvscreen(vsrow, vscol)
{
    Console.log("vsrow: " + vsrow + " vscol:" + vscol);
}

//screen map function
function select_screen_ip(index)
{
    //change table value when select value selected
    //this.options[this.options.selectedindex].value
    var name = "screenip" + index;

    console.log("select screen ip"+index);

    var sip = document.getElementById(name);
    var nip = sip.options[sip.options.selectedIndex].text;

    console.log(nip);
    var titem = document.getElementById('tbvsmaps').rows[index + 1].childNodes[1];
    titem.innerHTML = nip;
}

//Src Title
var addSrcTitle = function () {
    var colnum = 3;
    var tbody = document.getElementById('tbvsmaps');
    var tr = document.createElement('tr');

    for (var j=0; j<colnum; j++) {
        var th = document.createElement('th');
        if (j==(colnum-1)) {
            var textObj = document.createTextNode("IP Available");
            th.appendChild(textObj);
            th.style.width = "50%";
            th.align = "left";
        } else if (j==0) {
            var textObj = document.createTextNode("ID");
            th.appendChild(textObj);            
            th.style.width = "10%";
            th.align = "left";
        }
        else if (j==1) {
            var textObj = document.createTextNode("Current IP");
            th.appendChild(textObj);            
            th.style.width = "40%";            
            th.align = "left";
        }
        tr.appendChild(th);
    }

    tbody.appendChild(tr);
}

//add screen map item
var addScr = function (index, ip) {
    var colnum = 3;
    var tbody = document.getElementById('tbvsmaps'); //.children[0];
    var tr = document.createElement('tr');
    for(var j=0; j<colnum; j++){
        var td = document.createElement('td');
        if (j == 0) {
            var span = document.createElement('span');
            span.appendChild(document.createTextNode(""+index));
            td.appendChild(span);
        }
        else if (j == 1) {
            var p = document.createElement('p');
            p.innerHTML = ip;
            td.appendChild(p);                    
        }
        else {
            var p = document.createElement('p');
            var name = "screenip" + index;
            p.innerHTML = "<select class='form-control' style='overflow:left;' name='" + name + "' id='" + name + "' onchange='select_screen_ip("+index+")'>";
            //console.log(p.innerHTML);
            td.appendChild(p);           
        }  

        tr.appendChild(td);
    }
    tbody.appendChild(tr);
}

var ctrlip = document.location.host;
var ctrlmac = "";
var currentAudioInput = "";

//At the same time, just send only two message to server!
function handleData_Setup(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];

    //console.log(data);

    var ack = JSON.parse(data);

    if (ack && ack.devinfo)
    {
        var i       = 0;
        var j       = 0;
        var iencode = 0;
        var idecode = 0;

        var msdelayTime = 50;
        //var ictrl   = 0;
  
        //var devlistObj = document.getElementById("devlist1");     
        var devlistObj = document.createElement("select");
        for (var dev in ack.devinfo)
        {
            var device = ack.devinfo[i ++];

            //var newOption = new Option(device.devaddr+"("+device.devtype+")", i);
            var newOption = new Option(device.devaddr, i);
            newOption.setAttribute("title", device.devtype);

            devlistObj.options.add(newOption);
        }

        Console.log("find " + i + " devices:");

        //if (i == 0)
        //{
            //error_message("Not found devices!");
        //}

        i = 0;
        idecode = 0;
        iencode = 0;

        //remove old
        var sysipmacSelectObj = document.getElementById('sysipmac');
        var decipSelectObj = document.getElementById('deciplist');
        var encipSelectObj = document.getElementById('enciplist');
        var sersrcipSelectObj = document.getElementById('sersrciplist');
        var serdesipSelectObj = document.getElementById('serdesip');

        var sysextraFileSelectObj = document.getElementById('extraFile');
        for (i = sysextraFileSelectObj.options.length; i > 0; i --)
        { 
            sysextraFileSelectObj.options.remove(i-1);
        }
        sysextraFileSelectObj.options.add(new Option("vi", 0));
        sysextraFileSelectObj.options.add(new Option("ai", 0));
        sysextraFileSelectObj.options.add(new Option("venc", 0));
        sysextraFileSelectObj.options.add(new Option("aenc", 0));
        sysextraFileSelectObj.options.add(new Option("hdmi", 0));
        sysextraFileSelectObj.options.add(new Option("sys", 0));
        sysextraFileSelectObj.options.add(new Option("rc", 0));
        sysextraFileSelectObj.options.add(new Option("vb", 0));
        sysextraFileSelectObj.options.add(new Option("vda", 0));
        sysextraFileSelectObj.options.add(new Option("log", 0));
        sysextraFileSelectObj.options.add(new Option("grp", 0));
        sysextraFileSelectObj.options.add(new Option("ive", 0));
        sysextraFileSelectObj.options.add(new Option("chnl", 0));
        sysextraFileSelectObj.options.add(new Option("adec", 0));
        sysextraFileSelectObj.options.add(new Option("ao", 0));
        sysextraFileSelectObj.options.add(new Option("mpeg4e", 0));
        sysextraFileSelectObj.options.add(new Option("vdec", 0));
        sysextraFileSelectObj.options.add(new Option("vo", 0));
        sysextraFileSelectObj.options.add(new Option("h264e", 0));
        sysextraFileSelectObj.options.add(new Option("jpege", 0));
        sysextraFileSelectObj.options.add(new Option("vpss", 0));
        sysextraFileSelectObj.options.add(new Option("dsu", 0));
        sysextraFileSelectObj.options.add(new Option("rgn", 0));

        for (i = sysipmacSelectObj.options.length; i > 0; i --)
        { 
            sysipmacSelectObj.options.remove(i-1);
        }
        for (i = decipSelectObj.options.length; i > 0; i --)
        { 
            decipSelectObj.options.remove(i-1);
        }
        for (i = encipSelectObj.options.length; i > 0; i --)
        { 
            encipSelectObj.options.remove(i-1);
        }        
        for (i = sersrcipSelectObj.options.length; i > 0; i --)
        { 
            sersrcipSelectObj.options.remove(i-1);
        }
        for (i = serdesipSelectObj.options.length; i > 0; i --)
        { 
            serdesipSelectObj.options.remove(i-1);
        }    

        serdesipSelectObj.options.add(new Option("all", 0));

        i = 0;
        j = 0;
        for (var dev in ack.devinfo)
        {
            var device = ack.devinfo[i];

            // console.log(device.devaddr + " " + device.devtype + " " + sysipmacSelectObj.options.length);

            if (device.devtype == "decoder")
            {
                //addDev(tbdecoder, idecode, device.devaddr, "", device.devtype);
                var option = new Option(device.devaddr, j++); //device.devmac
                option.title = device.devmac;
                sysipmacSelectObj.options.add(option);
                if ((idecode == 0) && (iencode == 0))
                {
                    document.getElementById('sysip').value = device.devaddr;
                    document.getElementById('sysnetmask').value = device.devnetmask;
                    document.getElementById('sysgateway').value = device.devgateway;
                    document.getElementById('sysname').value = device.devname;
                    document.getElementById('syshostname').value = device.devhostname;
                }

                var cmd = "config set connect ";
                cmd += device.devaddr;
                cmd += ";";

                if (idecode == 0)
                {
                    cmd += "config get decoder params ";
                    cmd += device.devaddr;
                    cmd += ";";
                    cmd += "config get decoder device status ";
                    cmd += device.devaddr;
                    cmd += ";";
                }

                if (ws)
                {
                    ws.doSend(cmd);
                    //console.log(cmd);
                    sleep(50);
                }
                {
                    var option = new Option(device.devname+"  " + device.devaddr, idecode);
                    option.title = device.devaddr;
                    decipSelectObj.options.add(option);
                }
                // decipSelectObj.options.add(new Option(device.devaddr, idecode));
				
                {
                    var option = new Option(device.devname+"  " + device.devaddr, idecode + iencode);
                    option.title = device.devaddr;
                    sersrcipSelectObj.options.add(option);
                }
                // sersrcipSelectObj.options.add(new Option(device.devaddr, idecode + iencode));
				
                {
                    var option = new Option(device.devname+"  " + device.devaddr, idecode + iencode+1);
                    option.title = device.devaddr;
                    serdesipSelectObj.options.add(option);
                }
                // serdesipSelectObj.options.add(new Option(device.devaddr, idecode + iencode+1));

                idecode ++;
            }
            else if (device.devtype == "encoder")
            {
                //addDev(tbencoder, iencode, device.devaddr, "", device.devtype);
                var option = new Option(device.devaddr, j++);
                option.title = device.devmac;
                sysipmacSelectObj.options.add(option);
                if ((idecode == 0) && (iencode == 0))
                {
                    document.getElementById('sysip').value = device.devaddr;
                    document.getElementById('sysnetmask').value = device.devnetmask;
                    document.getElementById('sysgateway').value = device.devgateway;
                    document.getElementById('sysname').value = device.devname;
                    document.getElementById('syshostname').value = device.devhostname;
                }

                var cmd = "config set connect ";
                cmd += device.devaddr;
                cmd += ";";

                if (iencode == 0)
                {
                    cmd += "config get encoder params ";
                    cmd += device.devaddr;
                    cmd += ";";
                    cmd += "config get encoder device status ";
                    cmd += device.devaddr;
                    cmd += ";";
                }

                if (ws)
                {
                    ws.doSend(cmd);
                    //console.log(cmd);
                    sleep(50);
                }
                {
                    var option = new Option(device.devname+"  " + device.devaddr, iencode);
                    option.title = device.devaddr;
                    encipSelectObj.options.add(option);
                }
                // encipSelectObj.options.add(new Option(device.devaddr, iencode));
				
                {
                    var option = new Option(device.devname+"  " + device.devaddr, idecode + iencode);
                    option.title = device.devaddr;
                    sersrcipSelectObj.options.add(option);
                }
                // sersrcipSelectObj.options.add(new Option(device.devaddr, idecode + iencode));
				
                {
                    var option = new Option(device.devname+"  " + device.devaddr, idecode + iencode+1);
                    option.title = device.devaddr;
                    serdesipSelectObj.options.add(option);
                }
                // serdesipSelectObj.options.add(new Option(device.devaddr, idecode + iencode+1));

                iencode ++;
            }
            i ++;

            if (document.location.host.indexOf(device.devaddr) >= 0)
            {
                ctrlip = device.devaddr;
                ctrlmac = device.devmac;

                console.log("ctrip is " + ctrlip + " ctrlmac is " + ctrlmac);
            }            
        }
        close();

        //complete_message("Getting Devices Done!")

        //get vs screnn info after all device info
        var cmd = "config get device serial bynet params;";

        if (ws)
        {
            ws.doSend(cmd);
            //console.log(cmd);   
        }
        sleep(50);
    }
	else if (ack && ack.encparams)
    {
        //        console.log(ack.encparams);
        var encname = ack.encparams.devname;
        var encfps = ack.encparams.devFPS;
        var encratectrl = ack.encparams.devratecontrol;
        var encbitrate = ack.encparams.devbitrate;
        var encaudioin = ack.encparams.devaudiofrom;
        var encaudioout = ack.encparams.devaudioto;

        $("#encname").val(encname);
        $("#encfps").val(encfps);

        var encb = document.getElementById('encbitrate');

        if (encb && encb.options.length > 0)
        {
            if (encbitrate == 0)
                encb.options[0].selected = true;
            else
                encb.options[1].selected = true;
        }

        var encr = document.getElementById('encratectrl');

        if (encr && encr.options.length > 0)
        {
            if (encratectrl == 0)
                encr.options[1].selected = true;
            else
                encr.options[0].selected = true;
        }

        var encai = document.getElementById('encaudioin');

        if (encai && encai.options.length > 0)
        {
            if (encaudioin == 0)
            {
                encai.options[0].selected = true;
            }
            else
            {
                encai.options[1].selected = true;        
            }
            currentAudioInput = encai.options[encai.selectedIndex].text;
            Console.log("currentAudioInput: " + currentAudioInput);
        }

        var encao = document.getElementById('encaudioout');

        if (encao && encao.options.length > 0)
        {
            if (encaudioout == 0)
                encao.options[0].selected = true;
            else
                encao.options[1].selected = true;        
        }
    }
    else if (ack && ack.decparams)
    {
        var decname = ack.decparams.devname;
        var decluma = ack.decparams.devluma;
        var deccontrast = ack.decparams.devcontrast;
        var dechue = ack.decparams.devhue;
        var decsaturation = ack.decparams.devsaturation;
        var decaudio = ack.decparams.devaudiooutput;

        $("#decname").val(decname);
        $("#decluma").val(decluma);
        $("#deccontrast").val(deccontrast);
        $("#dechue").val(dechue);
        $("#decsaturation").val(decsaturation);

        var deca = document.getElementById('decaudio');
        if (deca && deca.options.length > 0)
        {
            if (decaudio == 0)
                deca.options[0].selected = true;
            else
                deca.options[1].selected = true;
        }
    }
    else if (ack && ack.versioninfo)
    {
        //console.log(data);
        Console.log("Version Info");
        Console.log("model: " + ack.versioninfo.model);

        var model = document.getElementById('model_version_info');
        model.innerHTML = ack.versioninfo.model;

        Console.log("version: " + ack.versioninfo.version);

        var version = document.getElementById('version_version_info');
        version.innerHTML = ack.versioninfo.version;    

        Console.log("build time: " + ack.versioninfo.buildtime);   

        var buildtime = document.getElementById('buildTime_version_info');
        buildtime.innerHTML = ack.versioninfo.buildtime;
		
        buildExtraIPSource(); // FangDa moved here we need support 2 model EXT-NETAVKIT & E8100
    }
    else if (ack && ack.ipsourcedev)
    {
        var j        = 0;
        var editflag = 0;
        var iipsource= 0;

        var esip_select = document.getElementById("esip_select");       
        var ip_source_radio = document.getElementsByName("ip_source_radio");

        if (ip_source_radio[1].checked == true)
        {
            editflag = 1;

            //edit mode, remove esip_select
            for (i = esip_select.options.length; i > 0; i --)
            { 
                esip_select.options.remove(i-1);
            }            
        }

        for (var dev in ack.ipsourcedev)
        {
            var ipsourcedev = ack.ipsourcedev[j++];

            if (editflag == 1)
            {
                esip_select.options.add(new Option(ipsourcedev.devaddr, ""));
            }

            if(iipsource == 0)
            {
                var cmdipsource = "config get ipsource params ";
                cmdipsource += ipsourcedev.devaddr;

                if (ws)
                {
                    ws.doSend(cmdipsource);
                    console.log(cmdipsource);                      
                } 
            }

            //console.log(data);
            iipsource ++;

            //console.log("ipsourcedev: " + ipsourcedev.devaddr);
            Console.log("ipsourcedev: " + ipsourcedev.devaddr);            
        }
    }
    else if (ack && ack.ipsourceparams)
    {
        var i        = 0;
        var j        = 0;
        var editflag = 0;

        var esip_select = document.getElementById("esip_select");
        var ip_source_radio = document.getElementsByName("ip_source_radio");

        if (ip_source_radio[1].checked == true)
        {
            editflag = 1;
        }

        if (editflag == 1)
        {           
            $("#esurl").val("");
            $("#esurlsub").val("");

            var devlistsource = ack.ipsourceparams.devtype;
            var esname = ack.ipsourceparams.devname;
            var esport = ack.ipsourceparams.port;
            var esuser = ack.ipsourceparams.user;
            var espass = ack.ipsourceparams.pass;
            //var channel = ack.ipsourceparams.channel;
            var esurl0 = ack.ipsourceparams.url_00;
            var esurl1 = ack.ipsourceparams.url_01;

            var ipsourcetype = document.getElementById('devlistsource');

            switch ( devlistsource ) {
            case 0:
                ipsourcetype.options[0].selected = true;
                break;
            case 1:
                ipsourcetype.options[1].selected = true;
                break;
            default:
                ipsourcetype.options[2].selected = true;
                break;
            }           

            $("#esname").val(esname);
            $("#esport").val(esport);
            $("#esuser").val(esuser);
            $("#espass").val(espass);

            //if(devlistsource > 1) // user define, need see url string
            //{

            var pos = esurl0.indexOf("?udp");
            if (pos != -1) 
            {
                esurl0 = esurl0.slice(0, pos);
                esurl1 = esurl1.slice(0, pos);
            }
            else
            {
                pos = esurl0.indexOf("?tcp");
                pos = esurl1.indexOf("?tcp");
                if (pos != -1) 
                {
                    esurl0 = esurl0.slice(0, pos);
                    esurl1 = esurl1.slice(0, pos);
                }
            }

            $("#esurl").val(esurl0);
            $("#esurlsub").val(esurl1);
            //}
        }

        //console.log(data);
        i ++;

        console.log("ipsourceparams: " + ack.ipsourceparams.devaddr);
    }
    else if (ack && ack.devicestatus)
    {
        //system status
        //console.log(ack.systemstatus);

        var devstatus = ack.devicestatus.status;
        var devinfo = ack.devicestatus.info;
        var devstatistics = ack.devicestatus.statistics;
        var devtype = ack.devicestatus.type;

        add_status_statistics(devtype, devinfo, devstatus, devstatistics); //device_info
    } 
    else if (ack && ack.netparams)
    {
        var sysip = ack.netparams.devip;
        var sysmac = ack.netparams.devmac;
        var sysnetmask = ack.netparams.devnetmask;
        var sysgateway = ack.netparams.devgateway;
        var sysname = ack.netparams.devname;
        var syshostname = ack.netparams.devhostname;	

        //Find controller out
        console.log("sysip is " + sysip);
        console.log("document.location.host is " + document.location.host);
        if (document.location.host.indexOf(sysip) >= 0)
        {
            ctrlip = sysip;
            ctrlmac = sysmac;

            console.log("ctrip is " + ctrlip + " ctrlmac is " + ctrlmac);
        }

        $("#sysip").val(sysip);
        $("#sysnetmask").val(sysnetmask);
        $("#sysgateway").val(sysgateway);
        $("#sysname").val(sysname);
        $("#syshostname").val(syshostname);		
    }
    else if (ack && ack.serparams)
    {
        var sip = ack.serparams.ip;
        var stype = ack.serparams.type;
        var sbaud = ack.serparams.baud;
        var sparity = ack.serparams.parity;
        var sstopbits = ack.serparams.stopbits;
        var sdatabits = ack.serparams.databits;
        var sbyneten = ack.serparams.byneten;
        var sbynetmode = ack.serparams.bynetmode;
        var sbynetip = ack.serparams.bynetip;
        if (sbynetip == "255.255.255.255") sbynetip = "all";
        if (sbynetip.length == 0) sbynetip = "all";

        // console.log(ack.serparams);
        if ((stype == "decoder") || (stype == "encoder"))
        {
            //decoder
            var serip = document.getElementById('sersrciplist');
            var serbaud = document.getElementById('serbaud');
            var serparity = document.getElementById('serparity');
            var serstopbits = document.getElementById('serstopbits');
            var serdatabits = document.getElementById('serdatabits');
            var serbyneten = document.getElementById('serserbynet');
            var serdesip = document.getElementById('serdesip');

            serip.selectedIndex = -1
            for (var i = 0; i < serip.options.length; i ++)
            {
                if (serip.options[i].title == sip) // if (serip.options[i].text == sip)
                {
                    serip.selectedIndex = i;
                }
            }

            serbaud.selectedIndex = -1
            for (var i = 0; i < serbaud.options.length; i ++)
            {
                if (parseInt(serbaud.options[i].text) == sbaud)
                {
                    serbaud.selectedIndex = i;
                }
            }
            serparity.selectedIndex = sparity;
            serstopbits.selectedIndex = sstopbits;

            if (sdatabits == "7")
                serdatabits.selectedIndex = 0;
            else
                serdatabits.selectedIndex = 1;

            serbyneten.checked = sbyneten && (sbynetmode == 0);
            serdesip.selectedIndex = -1
            for (var i = 0; i < serdesip.options.length; i ++)
            {
                if((i == 0) && (serdesip.options[i].text == sbynetip))
                {
                    serdesip.selectedIndex = i;
                    break;
                }
                else 
                {
                    if (serdesip.options[i].title == sbynetip) // if (serdesip.options[i].text == sbynetip)
                    {
                        serdesip.selectedIndex = i;
                        break;
                    }
                }
            }
        }
    }
    else if (ack && ack.serbynetparams) {
        var sip = ack.serbynetparams.ip;
        var stype = ack.serbynetparams.type;
        var sbaud = ack.serbynetparams.baud;
        var sparity = ack.serbynetparams.parity;
        var sstopbits = ack.serbynetparams.stopbits;
        var sdatabits = ack.serbynetparams.databits;
        var sbyneten = ack.serbynetparams.byneten;
        var sbynetmode = ack.serbynetparams.bynetmode;
        var sbynetip = ack.serbynetparams.bynetip;
        if (sbynetip == "255.255.255.255") sbynetip = "all";
        if (sbynetip.length == 0) sbynetip = "all";

        // console.log(ack.serparams);
        if ((stype == "decoder") || (stype == "encoder"))
        {
            //decoder
            var serip = document.getElementById('sersrciplist');
            var serbaud = document.getElementById('serbaud');
            var serparity = document.getElementById('serparity');
            var serstopbits = document.getElementById('serstopbits');
            var serdatabits = document.getElementById('serdatabits');
            var serbyneten = document.getElementById('serserbynet');
            var serdesip = document.getElementById('serdesip');

            serip.selectedIndex = -1
            for (var i = 0; i < serip.options.length; i ++)
            {
                if (serip.options[i].title == sip) // if (serip.options[i].text == sip)
                {
                    serip.selectedIndex = i;
                }
            }

            serbaud.selectedIndex = -1
            for (var i = 0; i < serbaud.options.length; i ++)
            {
                if (parseInt(serbaud.options[i].text) == sbaud)
                {
                    serbaud.selectedIndex = i;
                }
            }
            serparity.selectedIndex = sparity;
            serstopbits.selectedIndex = sstopbits;

            if (sdatabits == "7")
                serdatabits.selectedIndex = 0;
            else
                serdatabits.selectedIndex = 1;

            serbyneten.checked = sbyneten;
            serdesip.selectedIndex = -1
            for (var i = 0; i < serdesip.options.length; i ++)
            {
                if((i == 0) && (serdesip.options[i].text == sbynetip))
                {
                    serdesip.selectedIndex = i;
                    break;
                }
                else 
                {
                    if (serdesip.options[i].title == sbynetip) // if (serdesip.options[i].text == sbynetip)
                    {
                        serdesip.selectedIndex = i;
                        break;
                    }
                }
            }
        }
    }
/*   
    else if (ack.ipinfo)
    {
        var ipMode = ack.ipinfo.ipmode;
        ip4addr = ack.ipinfo.ip4addr;
        netmask = ack.ipinfo.netmask;
        gateway = ack.ipinfo.gateway;
        console.log("ipMode="+ipMode+" ip4addr="+ip4addr+" netmask="+netmask+" gateway="+gateway);

        if (ipMode == "static")
        {
            $("#ipmodeIPInfo").val(ipMode);
            
            $("#ip4addrIPInfo").val(ip4addr);
            $("#netmaskIPInfo").val(netmask);
            $("#gatewayIPInfo").val(gateway);
            $("#ip4addrIPInfo").attr("Disabled", false);
            $("#netmaskIPInfo").attr("Disabled", false);
            $("#gatewayIPInfo").attr("Disabled", false);
        }
        else if (ipMode == "autoip")
        {
            $("#ipmodeIPInfo").val(ipMode);
            
            $("#ip4addrIPInfo").val(ip4addr);
            $("#netmaskIPInfo").val(netmask);
            $("#gatewayIPInfo").val(gateway);
            
            $("#ip4addrIPInfo").attr("Disabled", true);
            $("#netmaskIPInfo").attr("Disabled", true);
            $("#gatewayIPInfo").attr("Disabled", true);
        }
        else if (ipMode == "dhcp")
        {
            $("#ipmodeIPInfo").val(ipMode);
        
            $("#ip4addrIPInfo").val(ip4addr);
            $("#netmaskIPInfo").val(netmask);
            $("#gatewayIPInfo").val(gateway);
            $("#ip4addrIPInfo").attr("Disabled", true);
            $("#netmaskIPInfo").attr("Disabled", true);
            $("#gatewayIPInfo").attr("Disabled", true);
        }        
    }
*/    
    else if (ack && ack.ack && ack.ack.cmd)
    {
        if (ack.ack.cmd == "config get login")
        {
            if (ack.ack.status != "success")
            {
                //error_message("no login!");

                document.location.href = "index.html";
                console.log("redirect to index.html!");

                return;
            }

        }
        else if (ack.ack.cmd.indexOf("config set device serial params") > -1)
        {
            if (ack.ack.status != "success")
            {
                alert("RS-232 set failed");

                return;
            }
        }
        else if (ack.ack.cmd.indexOf("config get controller master") > -1)
        {
            if (ack.ack.status == "success")
            {
                //alert("master!");
                var master = document.getElementById('multi-controller-master');
                master.checked = true;

                return;
            }
        }
        else if (ack.ack.cmd.indexOf("update get devices") > -1) // else if (ack.ack.cmd.indexOf("config get devices") > -1)
        {
            close();
        }
        else if (ack.ack.cmd.indexOf("config set device factory default") > -1)
        {
            alert("Reset controller to factory default finished");
        }

        Console.log(ack.ack.cmd +" return "+ ack.ack.status);
    }
}

//Called when setup.html loaded
function initSetupData()
{    
    // buildExtraIPSource();
    buildControls();
}

//get devices information from server
function updateDevices()
{
    // var searching_img = document.getElementById('searching_img');
    // searching_img.style = "";
    showLoader("searching device...");
    buildIPSource();

    if (ws)
    {
        var cmd = "update get devices;config get ipsources;"; // var cmd = "config get devices";

        ws.doSend(cmd);
        console.log(cmd);
    }

    ctrlip = document.location.host;
    ctrlmac = "";
}

function updateDevlist()
{
    //config get system status;"
    var cmd = "config get devlist;config get ipsources;";

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);  
    }

    ctrlip = document.location.host;
    ctrlmac = "";
}

//send cmd to device from cmd line (only function page)
function sendCmdToDevice()
{
    var message = document.getElementById('cmdLine1').value;

    if (message != '') {

        if (message == "clear")
        {
            var console = document.getElementById('console');       
            while (console.childNodes.length > 0) {
                console.removeChild(console.firstChild);
            }

            console.scrollTop = console.scrollHeight;           
        }
        else
        {
            ws.doSend(message);   
        }

        document.getElementById('cmdLine1').value = '';
    }
}

function clearCmd()
{
    document.getElementById('cmdLine1').value = "clear";

    sendCmdToDevice();
}

//check keyup event on cmdLine1
function keyup()
{
    if (event.keyCode == 13)
    {
        sendCmdToDevice();
    }
}

//add 0 before value to make value
function p0(s) 
{
    return s < 10 ? '0' + s: s;
}

//get time
function getTime()
{
    var thisDate = new Date();  
    var thisTimeString = p0(thisDate.getHours()) + ":" + p0(thisDate.getMinutes())+":"+p0(thisDate.getSeconds());

    return thisTimeString; 
}

//Communacation method
function radiocheckComm() {
    var rg = document.getElementsByName("commgroup1");
    for (var i = 0; i < rg.length; i ++) {             
        if (rg[i].checked) {
            // alert(i);
            //send cmd to server to get settings
            break;
        }
    }
}

function radiocheckDecoder() {
    var rg = document.getElementsByName("decgroup1");
    for (var i = 0; i < rg.length; i ++) {             
        if (rg[i].checked) {
            alert("decoder"+i);

            var tbObj = document.getElementById("tbdecoder");

            var ip = tbObj.rows[i + 1].childNodes[2].innerHTML;

            console.log(ip);

            ip = ip.replace(/<[^>]*>|/g,"");

            if (ip != null)
            {
                //send cmd to server to get settings
                var cmd = "config get decoder params ";
                cmd += ip;

                if (ws)
                {
                    ws.doSend(cmd);
                    console.log(cmd);                    
                }
            }
            break;
        }
    }
}

function radiocheckEncoder() {
    var rg = document.getElementsByName("encgroup1");
    for (var i = 0; i < rg.length; i ++) {             
        if (rg[i].checked) {
            alert("encoder"+i);

            var tbObj = document.getElementById("tbencoder");

            var ip = tbObj.rows[i + 1].childNodes[2].innerHTML;

            ip = ip.replace(/<[^>]*>|/g,"");

            if (ip != null)
            {
                //send cmd to server to get settings
                var cmd = "config get encoder params ";
                cmd += ip;

                if (ws)
                {
                    ws.doSend(cmd);
                    console.log(cmd);
                }                
            }

            break;
        }
    }
}

var addDevTitle = function (target) {
    var colnum = 5;
    var tbody = target.children[0];
    var tr = document.createElement('tr');

    for (var j=0; j<colnum; j++) {
        var th = document.createElement('th');
        if (j==(colnum-1)) {
            var textObj = document.createTextNode("Type");
            th.appendChild(textObj);
        } else if (j==1) {
            var textObj = document.createTextNode("ID");
            th.appendChild(textObj);            
        }
        else if (j==2) {
            var textObj = document.createTextNode("IP");
            th.appendChild(textObj);            
        }
        else if(j==3) {
            var textObj = document.createTextNode("Name");
            th.appendChild(textObj);
        }
        else{
            var textObj = document.createTextNode("");
            th.appendChild(textObj);
        }
        tr.appendChild(th);
    }

    tbody.appendChild(tr);
}

var addDev = function (target, index, ip, name, type) {
    var colnum = 5;
    var tbody = target.children[0];
    var tr = document.createElement('tr');
    for(var j=0; j<colnum; j++){
        var td = document.createElement('td');
        if(j==(colnum-1)){
            var p = document.createElement('p');
            p.innerHTML = type;
            td.appendChild(p);

        }else if (j==1) {
            var span = document.createElement('span');
            span.appendChild(document.createTextNode(""+index));
            td.appendChild(span);
        }
        else if (j==2) {
            var span = document.createElement('span');
            span.appendChild(document.createTextNode(ip));
            td.appendChild(span);
        }
        else if (j==3) {
            var span = document.createElement('span');
            span.appendChild(document.createTextNode(name));
            td.appendChild(span);
        }
        else{
            var p = document.createElement('p');
            if (target == tbencoder)
                p.innerHTML = "<input type='radio' name='encgroup1' onclick='javascript:radiocheckEncoder();'>";
            else if (target == tbdecoder)
                p.innerHTML = "<input type='radio' name='decgroup1' onclick='javascript:radiocheckDecoder();'>";

            td.appendChild(p);
        }

        tr.appendChild(td);
    }
    tbody.appendChild(tr);
}

//build extra ip source
function buildExtraIPSource()
{
    var devlistObj = document.getElementById("devlistsource");
    var modelcheck = document.getElementById('model_version_info').innerHTML;

    for (var iCnt = devlistObj.options.length; iCnt > 0; iCnt --)
    { 
        devlistObj.options.remove(iCnt-1);
    }
	{
		if(modelcheck == "EXT-NETAVKIT") {
			var type;
			type = "User define";
			devlistObj.options.add(new Option(type, ""));
		}
		else {
			var count = 3;
			var type;
			for (var i = 0; i < count; i ++)
			{
				if (i == 0)
					type = "dahua";
				else if (i == 1)
					type = "haikang";
				else
					type = "User define";

				devlistObj.options.add(new Option(type, ""));
			}
		}
	}
}

function buildControls()
{
    //Decoder
    //HDMI/Extra Line output
    var decaudio = document.getElementById('decaudio');
    decaudio.options.add(new Option("Extra Line", 0)); 
    decaudio.options.add(new Option("HDMI", 0));
    decaudio.options[0].selected = true; //HDMI

    //Serial settings
    var devlistObjE = document.getElementById("serbaud");

    devlistObjE.options.add(new Option("115200", ""));
    devlistObjE.options.add(new Option("57600", ""));
    devlistObjE.options.add(new Option("19200", ""));
    devlistObjE.options.add(new Option("9600", ""));

    devlistObjE = document.getElementById("serparity");

    devlistObjE.options.add(new Option("none", ""));
    devlistObjE.options.add(new Option("odd", ""));
    devlistObjE.options.add(new Option("even", ""));

    devlistObjE = document.getElementById("serstopbits");

    devlistObjE.options.add(new Option("0", ""));
    devlistObjE.options.add(new Option("1", ""));
    devlistObjE.options.add(new Option("2", ""));

    devlistObjE = document.getElementById("serdatabits");

    devlistObjE.options.add(new Option("7", ""));
    devlistObjE.options.add(new Option("8", ""));

    //Encoder Settings
    var devlistObjES = document.getElementById("encbitrate");
    devlistObjES.options.add(new Option("High", ""));
    devlistObjES.options.add(new Option("Normal", ""));

    var devlistObjEC = document.getElementById("encratectrl");
    devlistObjEC.options.add(new Option("VBR", ""));
    devlistObjEC.options.add(new Option("CBR", ""));

    //HDMI/Extra Line in
    var encaudioin = document.getElementById('encaudioin');
    encaudioin.options.add(new Option("HDMI", 0));
    encaudioin.options.add(new Option("Extra Line", 0));    
    encaudioin.options[0].selected = true; //HDMI    

    var encaudioout = document.getElementById('encaudioout');
    encaudioout.options.add(new Option("HDMI", 0));
    encaudioout.options.add(new Option("Extra Line", 0));    
    encaudioout.options[1].selected = true; //Line Out    

    //IP Source Page
    var esip_text   = document.getElementById("esip_text");
    esip_text.value = "192.168.1.100"; 

    var esname   = document.getElementById("esname");
    esname.value = "CAM"; 

    var esport   = document.getElementById("esport");
    esport.value = "554";

    var esuser   = document.getElementById("esuser");
    esuser.value = "admin";

    var espass = document.getElementById("espass");
    espass.value = "admin";     

    var esurl = document.getElementById("esurl");
    esurl.value = "rtsp://";
    esurl.setAttribute('clospan', 3);
    var esurlsub = document.getElementById("esurlsub");	
    esurlsub.value = "rtsp://";
    esurlsub.setAttribute('clospan', 3);	

    var rg = document.getElementsByName("commgroup1");
    rg[1].checked = true; //udp

    var ip_source_radio = document.getElementsByName("ip_source_radio");
    ip_source_radio[0].checked = true; //add

    var ip_source_delete = document.getElementById("ip_source_delete");
    ip_source_delete.disabled = true;

    //build ipsource url accroding as ip, type, user, pass etc
    // build_ipsource_url();
}

//For control devices
//Functions 

//System page
function multi_controller_settings()
{
    var checked = document.getElementById('multi-controller-master');
    var hostip = document.location.host;
    if (!hostip) hostip = "127.0.0.1";

    if (ws)
    {
        var cmd  = "config set controller master ";
        cmd += hostip;
        cmd += " ";
        cmd += checked.checked ? 1 : 0;
        ws.doSend(cmd);
        console.log(cmd);
    }
}

function ip_mode_change()
{

}

function device_reboot()
{
    //ip4addripinfo
    //var ip = document.getElementById('ip4addripinfo');
    var hostip = document.location.host;

    if (hostip.length == 0) {
        hostip = "127.0.0.1";
    }

    var cmd = "config set reboot ";
    cmd += hostip;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);

        var setup_page = document.getElementById('setup_page');
        setup_page.style.visibility = "hidden";
        showReboot(hostip);
    }
}

function device_factory_default()
{
    //var ip = document.getElementById('ip4addripinfo');
    var hostip = document.location.host;

    if (hostip.length == 0) {
        hostip = "127.0.0.1";
    }

    var cmd = "config set device factory default";

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);

        var setup_page = document.getElementById('setup_page');
        setup_page.style.visibility = "hidden";
        showReboot(hostip);		
    }    
}

function control_ip_apply()
{
    var ip = document.getElementById('ip4addripinfo');
    var netmask = document.getElementById('netmaskipinfo');
    var gateway = document.getElementById('gatewayipinfo');
    var listObj1 = document.getElementById('ipmodeipinfo');

    var mode = listObj1.options[listObj1.selectedIndex].text;

    var cmd = "config set system network ";
    cmd += mode;
    cmd += " ";
    cmd += ip;
    cmd += " ";
    cmd += netmask;
    cmd += " ";
    cmd += gateway;

    if (ws)
    {
        ws.doSend(cmd);
    }
}

function change_password_apply()
{
    var pass = document.getElementById('newpassword');

    var cmd = "config set system pass ";
    cmd += pass.value;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);

        //complete_message("Change Password Done!");
    }    
}

function add_status_statistics(type, sysinfo, sysstatus, sysstatistics)
{
    //check sysinfo to know decoder or encoder
    var device_info;

    if (type == "encoder")
    {
        device_info = document.getElementById('enc_device_info'); //device_info
    }
    else if (type == "decoder")
    {
        device_info = document.getElementById('dec_device_info'); //device_info
    }
    else
    {
        //not support now!

        //dec = document.getElementById('sys_device_info'); //device_info
        return;
    }
    while (device_info.hasChildNodes())
    {
        device_info.removeChild(device_info.firstChild);
    }

    var infoes = sysinfo.split(";");

    for (var i = 0; i < infoes.length; i ++)
    {
        var info = document.createElement('p');
        info.innerHTML = infoes[i];
        device_info.appendChild(info);
    }
}

function decoder_status_statistics_refresh()
{
    var listObj1 = document.getElementById('deciplist');
    var ip = listObj1.options[listObj1.selectedIndex].title;
    // var ip = listObj1.options[listObj1.selectedIndex].text;
    var cmd = "config get decoder device status ";
    cmd += ip;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
        //complete_message("Refresh Status Done!")        
    }
}

function encoder_status_statistics_refresh()
{
    var listObj1 = document.getElementById('enciplist');
	var ip = listObj1.options[listObj1.selectedIndex].title;
    // var ip = listObj1.options[listObj1.selectedIndex].text;
    var cmd = "config get encoder device status ";
    cmd += ip;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
        //complete_message("Refresh Status Done!")        
    }
}

function system_changevideowallid()
{
    var listObj1 = document.getElementById('vidiowallid');
    var videowallid = listObj1.options[listObj1.selectedIndex].value;
	
    var cmd = "scene id get ";
    cmd += videowallid;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
    }
}

//Select ip&mac to load ip, netmask, gateway values
function system_changeipmac()
{
    var listObj1 = document.getElementById('sysipmac');
    var mac = listObj1.options[listObj1.selectedIndex].title;

    var cmd = "config get net params ";
    cmd += mac;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);

        //complete_message("Change Mac Done!")
    }
}

//change ip, netmask, gateway apply!
function system_changeip_apply()
{
    var changectrlip = 0;

    var listSysIPMac = document.getElementById('sysipmac');
    var mac = listSysIPMac.options[listSysIPMac.selectedIndex].title;
    var ipOrg = listSysIPMac.options[listSysIPMac.selectedIndex].text;

    var ip = document.getElementById('sysip').value;
    var netmask = document.getElementById('sysnetmask').value;
    var gateway = document.getElementById('sysgateway').value;
    var name = document.getElementById('sysname').value;

    if ((checkIPValid(ip, 0) == false) || (checkIPValid(netmask, 1) == false) || (checkIPValid(gateway, 2) == false))
    {
        return;
    }
	if(name.length == 0)
	{
		alert("Invalid Name!");
		return;
	}

    if (document.location.host.indexOf("127.0.0.1") >= 0 || document.location.host.length == 0)
    {
        //test only!
        changectrlip = 1;
    }

    if ((ctrlmac.length > 0) && mac.indexOf(ctrlmac) >= 0)
    {
        if ((ip.indexOf(ctrlip) < 0) || (ctrlip.length == 0) || (ip.length == 0))
        {
            changectrlip = 1;
            console.log("changectrlip!");
        }
        //else
        //{
            //no change, return
            //console.log("ip no change!");
            //return;
        //}
    }

    var cmd = "config set decoder name ";
    cmd += ipOrg;
    cmd += " ";
    cmd += name;
	
    cmd += ";config set encoder name ";
    cmd += ipOrg;
    cmd += " ";
    cmd += name; 	
	
    cmd += ";config set net params ";
    cmd += mac;
    cmd += " ";
    cmd += ip;
    cmd += " ";
    cmd += netmask;
    cmd += " ";
    cmd += gateway;
    /*
    var cmd = "config set netandname params ";
    cmd += mac;
    cmd += " ";
    cmd += ip;
    cmd += " ";
    cmd += netmask;
    cmd += " ";
    cmd += gateway;
    cmd += " ";
    cmd += name;
    */

    if(ip != ipOrg)
    {
        cmd += ";config get devlist";
        cmd += ";config get vs screen params";
    }

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
    }

    //sync list value and ip value
    listSysIPMac.options[listSysIPMac.selectedIndex].text = ip;

    if (changectrlip)
    {
        var setup_page = document.getElementById('setup_page');
        setup_page.style.visibility = "hidden";
        showReboot(ip);
    }
    //else
    //{
    //    //reload current page!
    //console.log("reload page!");
    //window.location.href=window.location.href; 
    //window.location.reload;        
    //}
}
 //import file
function selectFile(target){
    var name=target.value;
    var fileName = name.substring(name.lastIndexOf(".")+1).toLowerCase();
    var files = document.getElementById('file_csv').files;     
    if(fileName !="csv"){
      	document.getElementById("pop_box").style.display='block';
      	document.getElementById("mask").style.display='block';
      	//显示提示
         setTimeout(function(){         	
         		document.getElementById("pop_box").style.display='none';
         		document.getElementById("mask").style.display='none';
         },3000)
          target.value="";
          return
    }
    // document.getElementById("selectMark").innerHTML=files[0].name;
}

function system_changecheck_apply()
{
    if (ws)
    {
        var cmd = "config set decoders display ip";
        ws.doSend(cmd);
        console.log(cmd);
    }
}

//Select ip&mac to load ip, netmask, gateway values
function serial_changeip()
{
    var listObj1 = document.getElementById('sersrciplist');
    var ip = listObj1.options[listObj1.selectedIndex].title; // var ip = listObj1.options[listObj1.selectedIndex].text;

    var cmd = "config get device serial params "; // "config get net params ";
    cmd += ip;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);

        //complete_message("get device serial params!")
    }
}

function device_serial_set()
{
    var listObj0 = document.getElementById('sersrciplist');
    var ip = listObj0.options[listObj0.selectedIndex].title; // var ip = listObj0.options[listObj0.selectedIndex].text;

    //get encoder serial setting
    var listObj1 = document.getElementById('serbaud');
    var baud = listObj1.options[listObj1.selectedIndex].text;

    var listObj2 = document.getElementById('serparity');
    var parity = listObj2.selectedIndex;

    var listObj3 = document.getElementById('serstopbits');
    var stopbits = listObj3.selectedIndex;

    var listObj4 = document.getElementById('serdatabits');
    var databits = listObj4.options[listObj4.selectedIndex].text; // listObj4.selectedIndex;

    var checkbox = document.getElementById('serserbynet');
    var checked = checkbox.checked ? 1 : 0;

    var listObj5 = document.getElementById('serdesip');
    var destip = "";

    if (listObj5.selectedIndex > -1) {
        destip = listObj5.options[listObj5.selectedIndex].title;
    }
    if (listObj5.selectedIndex == 0) {
        destip = listObj5.options[listObj5.selectedIndex].text;
    }
    // destip = listObj5.options[listObj5.selectedIndex].text;

    if (ip == destip)
    {
        alert("RS-232 Source IP and Destination IP should be different");

        return;
    }

    var cmd  = "config set device serial params ";
    cmd += ip;
    cmd += " ";
    cmd += baud;
    cmd += " "; 
    cmd += databits;
    cmd += " ";
    cmd += parity;
    cmd += " "; 
    cmd += stopbits;
    cmd += " "; 
    cmd += checked;
    cmd += " ";
    cmd += "0";
    cmd += " ";
    cmd += destip;  

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);

        //complete_message("Change Serial Settings Done!")
    }

    //alert("Serial Settings updated!");
}

//For virtual screen page
function apply_vs_maps()
{
    var tbObj = document.getElementById("tbvsmaps");

    var id = 0;
    var ip = "";
    var cmd = "config set vs screen params ";
    var cmdsize = "";
    var cmdips = "";

    var vsrow = document.getElementById("vsrow").value;  
    var vscol = document.getElementById("vscol").value;
    var vshorcut = document.getElementById("vshorcut").value;  
    var vsvercut = document.getElementById("vsvercut").value;

    if (parseInt(vsrow) > 4 || parseInt(vscol) > 4 || (parseInt(vsrow) == 0) || (parseInt(vscol) == 0))
    {
        alert("Sorry, current firmware video wall max supports up to 4x4.");

        return;
    }
    if (parseInt(vshorcut) > 8 || parseInt(vsvercut) > 8 || (parseInt(vshorcut) < 0) || (parseInt(vsvercut) < 0))
    {
        alert("Sorry, current firmware video wall max supports Horizontal Edge Compensation or Vertical Edge Compensation up to 8.");

        return;
    }

    cmdsize += vsrow;
    cmdsize += " ";
    cmdsize += vscol;
    cmdsize += " ";
    cmdsize += vshorcut;
    cmdsize += " ";
    cmdsize += vsvercut;

    cmd = cmd + cmdsize;

    if (ws)
    {
        cmd += ";config get vs all params"; // ";config get vs screen params"; // +=: Update UI
        cmd += ";config set decoders display ip";
        ws.doSend(cmd);
        console.log(cmd);

        //complete_message("Virtual Screen Maps Changed!");     
    }
}

function apply_vs_cut()
{
    var tbObj = document.getElementById("tbvsmaps");

    var id = 0;
    var ip = "";
    var cmd = "config set vs rowcolumncutedge params ";
    var cmdsize = "";
    var cmdips = "";

    var vshorcut = document.getElementById("vshorcut").value;  
    var vsvercut = document.getElementById("vsvercut").value;

    if (parseInt(vshorcut) > 8 || parseInt(vsvercut) > 8 || (parseInt(vshorcut) < 0) || (parseInt(vsvercut) < 0))
    {
        alert("Sorry, current firmware video wall max supports Horizontal Edge Compensation or Vertical Edge Compensation up to 8.");

        return;
    }

    cmdsize += vshorcut;
    cmdsize += " ";
    cmdsize += vsvercut;
    cmdsize += " ";

    cmd = cmd + cmdsize;

    if (ws)
    {
        // cmd += ";config get vs all params"; // ";config get vs screen params"; // +=: Update UI
        // cmd += ";config set decoders display ip";
        ws.doSend(cmd);
        // console.log(cmd);

        //complete_message("Virtual Screen cut Changed!");
    }
}

//For Decoder page
function decoder_changeip()
{
    var listObj1 = document.getElementById('deciplist');
    var ip = listObj1.options[listObj1.selectedIndex].title;	
    // var ip = listObj1.options[listObj1.selectedIndex].text;

    var cmd = "config get decoder params ";
    cmd += ip;
    cmd += ";";
    cmd += "config get decoder device status ";
    cmd += ip;            

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
    }
}

//update user information to server
function decoder_settings_apply()
{
    //config set encoder params 192.168.1.26 name ip 0 0 1000 2048
    //encname
    var name = document.getElementById('decname').value;

    //decluma
    var decluma = document.getElementById('decluma').value;

    //deccontrast
    var deccontrast = document.getElementById('deccontrast').value;

    //decsaturation
    var decsaturation = document.getElementById('decsaturation').value;

    //dechue
    var dechue = document.getElementById('dechue').value;

    var listObj1 = document.getElementById('deciplist');
    var ip = listObj1.options[listObj1.selectedIndex].title;	
    // var ip = listObj1.options[listObj1.selectedIndex].text;

    var listObj2 = document.getElementById('decaudio');
    var audiodec = listObj2.options[listObj2.selectedIndex].text;   

    if ((parseInt(decluma) > 100) || (parseInt(deccontrast) > 100) || (parseInt(decsaturation) > 100) || (parseInt(dechue) > 100))
    {
        alert("RX settings value must be 0 - 100!");

        return;
    }

    if (ip != null)
    {
        var cmd  = "config set decoder params ";
        cmd += ip;
        cmd += " ";
        cmd += decluma;
        cmd += " "; 
        cmd += deccontrast;
        cmd += " "; 
        cmd += dechue;
        cmd += " "; 
        cmd += decsaturation;
        if (audiodec == "HDMI")
        {
            cmd += " ";
            cmd += "1"
        }
        else if (audiodec == "Extra Line")
        {
            cmd += " ";
            cmd += "0";
        }
        cmd += " ";
        cmd += name; // index is 6

        if (ws)
        {
            ws.doSend(cmd);
            console.log(cmd);
            //complete_message("Decoder Settings Changed!");               
        }
        // alert("Decoder Settings updated!");             
    }
}

//For Encoder page
function encoder_changeip()
{
    var listObj1 = document.getElementById('enciplist');
	var ip = listObj1.options[listObj1.selectedIndex].title;
    //var ip = listObj1.options[listObj1.selectedIndex].text;

    var cmd = "config get encoder params ";
    cmd += ip;
    cmd += ";";
    cmd += "config get encoder serial params ";
    cmd += ip;
    cmd += ";";
    cmd += "config get encoder device status ";
    cmd += ip;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);        
    }
}

function encoder_settings_apply()
{
    //config set encoder params 192.168.1.26 name ip 0 0 1000 2048
    //encname
    var name = document.getElementById('encname').value;

    //encfps
    var fps = document.getElementById('encfps').value;

    //encratectrl
    var listObj1 = document.getElementById('encratectrl');
    var ratectrl = listObj1.options[listObj1.selectedIndex].text;

    //encbitrate
    var listObj2 = document.getElementById('encbitrate');
    var bitrate  = listObj2.options[listObj2.selectedIndex].text;

    var listObj3 = document.getElementById('enciplist');
    var ip = listObj3.options[listObj3.selectedIndex].title;
    //var ip = listObj3.options[listObj3.selectedIndex].text;

    var listObj4 = document.getElementById('encaudioin');
    var audioin = listObj4.options[listObj4.selectedIndex].text;    

    var listObj5 = document.getElementById('encaudioout');
    var audioout = listObj5.options[listObj5.selectedIndex].text;    

    if (ip != null)
    {
        var cmd  = "config set encoder params ";
        cmd += ip;
        cmd += " ";
        cmd += "0";
        cmd += " "; 
        cmd += "1";
        cmd += " ";                                    
        cmd += fps;
        cmd += " ";
        if (ratectrl == "VBR")
        {   
            if (bitrate == "High")
            {
                cmd += "24000";
                cmd += " ";
                cmd += "1"; 
            }
            else if (bitrate == "Normal")
            {                        
                cmd += "8000";
                cmd += " "; 
                cmd += "1"; 
            }                     
        }
        else if(ratectrl == "CBR")
        {
            if (bitrate == "High")
            {
                cmd += "12000";
                cmd += " "; 
                cmd += "0"; 
            }
            else if (bitrate == "Normal")
            {                        
                cmd += "6000";
                cmd += " "; 
                cmd += "0"; 
            }
        }

        if (audioin == "HDMI")
        {
            cmd += " ";
            cmd += "0"
        }
        else if (audioin == "Extra Line")
        {
            cmd += " ";
            cmd += "1";
        }

        if (audioout == "HDMI")
        {
            cmd += " ";
            cmd += "0"
        }
        else if (audioout == "Extra Line")
        {
            cmd += " ";
            cmd += "1";
        }

        cmd += " ";
        cmd += name; // index is 8 (0 base)

        if (ws)
        {
            ws.doSend(cmd);
            console.log(cmd);            
            //complete_message("Encoder Settings Changed!");              
        }
		
//		if((currentAudioInput != audioin) && (ip == ctrlip))
//		{
//			var tx_setting_page = document.getElementById('TX_Setting_page');
//			tx_setting_page.style.visibility = "hidden";
//			showReboot(ip);
//		}
        // alert("Decoder Settings updated!");             
    } 
}

//For IP Source
function radiocheckIPSource()
{
    var ip_source_radio = document.getElementsByName("ip_source_radio");
    var tbObj = document.getElementById("tbipsource");

    if (ip_source_radio[0].checked)
    {
        //add
        tbObj.rows[1].childNodes[3].innerHTML = "<input type='text' style='height:25px;' id='esip_text' />";
        var esip_text   = document.getElementById("esip_text");
        esip_text.value = "192.168.1.100";

        var esname   = document.getElementById("esname");
        esname.value = "CAM"; // esip_text.value; // "unknown"; 

        var esport   = document.getElementById("esport");
        esport.value = "554";

        var esuser   = document.getElementById("esuser");
        esuser.value = "admin";

        var espass = document.getElementById("espass");
        espass.value = "admin";     

        var esurl = document.getElementById("esurl");
        esurl.value = "rtsp://";
        esurl.setAttribute('clospan', 3);

        var esurlsub = document.getElementById("esurlsub");
        esurlsub.value = "rtsp://";
        esurlsub.setAttribute('clospan', 3);		

        build_ipsource_url();

        var ip_source_delete = document.getElementById("ip_source_delete");
        ip_source_delete.disabled = true;   
    }
    else
    {
        //edit
        tbObj.rows[1].childNodes[3].innerHTML = "<select class='form-control' style='overflow:left;' name='esip_select' id='esip_select' i onchange='javascript:select_ipsource_ip();'></select>";

        var ip_source_delete = document.getElementById("ip_source_delete");
        ip_source_delete.disabled = false;

        var cmd = "config get ipsources";
        ws.doSend(cmd);
        console.log(cmd);
    }
    //console.log(tbObj.rows[1].childNodes[2].innerHTML);
}

function select_ipsource_ip()
{
    //select device ip for ip source
    var listObj = document.getElementById('esip_select');
    var ip = listObj.options[listObj.selectedIndex].text;

    var cmd = "config get ipsource params ";
    cmd += ip;

    if (ws)
    {
        ws.doSend(cmd);
    }
    console.log(cmd);
}

function ip_source_apply()
{
    //commgroup1
    //devlistsource
    //esip
    //esname
    //esport
    //esuser
    //esliveport
    //espass
    //eschannel

    var listObj1 = document.getElementById('devlistsource');
    var type = listObj1.selectedIndex;

    //ip
    var ip_source_radio = document.getElementsByName("ip_source_radio");
    var ip;
    var addflag = 0;

    if (ip_source_radio[0].checked)
    {
        //add
        ip = document.getElementById('esip_text').value;
        addflag = 1;
    }
    else
    {
        var listObj2 = document.getElementById('esip_select');
        var ip = listObj2.options[listObj2.selectedIndex].text;  
        addflag = 0;
    }

    //name
    var name = document.getElementById('esname').value;
    if (name.length == 0) name = "CAM"; 

    //port
    var port = document.getElementById('esport').value;
    if (port.length == 0) port = "554"; 

    //user
    var user = document.getElementById('esuser').value;

    //pass
    var pass = document.getElementById('espass').value;      

    //url
    var url = document.getElementById('esurl').value;       
    if (url.length == 0)
    {
        alert("Invalid url address");

        return;
    }
    var urlsub = document.getElementById('esurlsub').value;       
    if (urlsub.length == 0)
    {
        alert("Invalid url address");

        return;
    }	

    var rg = document.getElementsByName("commgroup1");
    for (var i = 0; i < rg.length; i ++) {             
        if (rg[i].checked) {
            //alert("comm"+i);

            if (ip != null)
            {
                var cmd  = "config set ipsource params ";
                cmd += ip;
                cmd += " ";
                cmd += type;
                cmd += " ";
                cmd += name;
                cmd += " "; 
                cmd += port;
                cmd += " "; 
                cmd += user;
                cmd += " "; 
                cmd += pass;
                cmd += " "; 
                cmd += url;
                cmd += " ";

                //communication mode must be follow to url and user
                if (i == 0)
                {
                    cmd += "?tcp";
                }
                else if (i == 1)
                {
                    cmd += "?udp";
                }
                else
                {
                    cmd += "?multicast";
                }

                // "ipc set params"), "%s %s %s %s %s %s %s", pcAlias, pcIP, pcMainSub, pcPort, pcUser, pcPass, pcUrl);
                cmd += ";ipc set params ";
                cmd += name;
                cmd += " "; 				
                cmd += ip;
                cmd += " ";
                cmd += "sub ";
                cmd += port;
                cmd += " "; 
                cmd += user;
                cmd += " "; 
                cmd += pass;
                cmd += " "; 
                cmd += urlsub;
                cmd += " ";

                //communication mode must be follow to url and user
                if (i == 0)
                {
                    cmd += "?tcp";
                }
                else if (i == 1)
                {
                    cmd += "?udp";
                }
                else
                {
                    cmd += "?multicast";
                }

                if (ws)
                {
                    ws.doSend(cmd);
                    console.log(cmd);
                    //complete_message("IPSource Settings Changed!");                       
                }

                //alert("IP Source Add/update settings!");             
            }

            break;
        }
    } 
}

function ip_source_delete()
{
    //ip
    var ip_source_radio = document.getElementsByName("ip_source_radio");
    var ip;
    var listObj1 = document.getElementById('esip_select');

    if (ip_source_radio[0].checked)
    {
        //add
        ip = document.getElementById('esip_text').value;
    }
    else
    {
        ip = listObj1.options[listObj1.selectedIndex].text;  
    }

    var cmd  = "config del ipsource params ";
    cmd += ip;

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
        //complete_message("IPSource Settings Changed!");

        if (listObj1.options.length == 1)
        {
            //the last one
            listObj1.options.remove(0);
        }
        else
        {
            //get ipsources again!
            cmd = "config get ipsources";
            ws.doSend(cmd);
            console.log(cmd);            
        }
    }
}

function select_extraFile()
{
    if (ws)
    {
        var sysextraFileSelectObj = document.getElementById('extraFile');
        var extrafile = sysextraFileSelectObj.options[sysextraFileSelectObj.selectedIndex].text;

        cmd = "config get extra info ";
        cmd += extrafile;
        ws.doSend(cmd);
        console.log(cmd);
    }
}

function select_ipsource_type()
{
    build_ipsource_url();
}

//build ipsource url accroding as ip, type, user, pass etc
function build_ipsource_url()
{
    console.log("build_ipsource_url!");
    var listObj1 = document.getElementById('devlistsource');
    var type = listObj1.options[listObj1.selectedIndex].text;

    var ip;
    var ip_source_radio = document.getElementsByName("ip_source_radio");    
    if (ip_source_radio[0].checked)
    {
        //add
        ip = document.getElementById('esip_text').value;
    }
    else
    {
        ip = listObj1.options[listObj1.selectedIndex].text;  
    }    

    //name
    var esname = document.getElementById('esname');    

    //name
    var esport = document.getElementById('esport');
    var port = "";

    //if (parseInt(esport.value) == 554)
    //{
    //    port = "";
    //}
    //else
    //{
    port = ":" + esport.value;
    //}

    //user
    var esuser = document.getElementById('esuser');

    //pass
    var espass = document.getElementById('espass');

    //url
    var url = document.getElementById('esurl');

    var urlsub = document.getElementById('esurlsub');

    var communication = "";
    var rg = document.getElementsByName("commgroup1");
    for (var i = 0; i < rg.length; i ++) {             
        if (rg[i].checked) {

            if (i == 0)
            {
                communication += "?tcp";
            }
            else if (i == 1)
            {
                communication += "?udp";
            }
            else
            {
                communication += "?multicast";
            }          

            break;
        }
    }

    var params = "";
    var paramssub = "";	

    var modelcheck = document.getElementById('model_version_info').innerHTML;
	
    if(modelcheck == "EXT-NETAVKIT") {
        if (type.indexOf("User define") >= 0)
        {
            params = "rtsp://" + ip + port;
            paramssub = "rtsp://" + ip + port;
        }
        else
        {
            params = "rtsp://";
            paramssub = "rtsp://";
        }
    }
    else {
        if (type.indexOf("dahua") >= 0)
        {
            //dahua rtsp://[user]:[pass]@[ip]:[port]/[codec]/[channel]/[subtype]/av_stream
            params = "rtsp://" + esuser.value + ":" + espass.value + "@" + ip + port + "/cam/realmonitor?channel=1&subtype=0";
            paramssub = "rtsp://" + esuser.value + ":" + espass.value + "@" + ip + port + "/cam/realmonitor?channel=1&subtype=1";
        }
        else if (type.indexOf("haikang") >= 0)
        {
            //haikang rtsp://[username]:[password]@[ip]:[port]/[codec]/[channel]/[subtype]/av_stream
            params = "rtsp://" + esuser.value + ":" + espass.value + "@" + ip + port + "/h264/ch1/main/av_stream";
            paramssub = "rtsp://" + esuser.value + ":" + espass.value + "@" + ip + port + "/h264/ch1/sub/av_stream";
        }
        else if (type.indexOf("User define") >= 0)
        {
            params = "rtsp://" + ip + port;
            paramssub = "rtsp://" + ip + port;
        }
        else
        {
            params = "rtsp://";
            paramssub = "rtsp://";
        }
    }

    url.value = params;    
    urlsub.value = paramssub;
}

//Update RX name UI (hidden) value when RX name changed in main page
function setuprxnamesync()
{
    //do nothing so far;
}

//Update TX name UI (hidden) value when TX name changed in main page
function setuptxnamesync()
{
    //do nothing so far;
}

//Update IP name UI (hidden) value when IP name changed in main page
function setupipnamesync()
{
    //do nothing so far;
}
