//setup.js
//
//Socket open callback
//function socketOpened()
//{
//    update_updateDevices(); 
//}

var Console = {};

Console.log = (function(message) {
    var console = document.getElementById('console');
    var p = document.createElement('p');

    p.style.wordWrap = 'break-word';
    p.innerHTML = getTime() + "&nbsp;&nbsp;&nbsp;" + message;

    console.appendChild(p);
    
    while (console.childNodes.length > 20) {
        console.removeChild(console.firstChild);
    }
    
    console.scrollTop = console.scrollHeight;
});

var file; //file object for file trans
var curobj; //current control object

//At the same time, just send only two message to server!
function handleData_Update(data)
{
    var vals    = data.split("\t");
    var msgType = vals[0];
   
    //console.log(data);     
    var ack = JSON.parse(data);
	
    if (ack && ack.devinfo)
    {
    	var i       = 0;
    	var j       = 0;		
     	
        var enclistObj = document.getElementById("list_enc");           
        var declistObj = document.getElementById("list_dec");       

        for (i = enclistObj.options.length; i > 0; i --)
        { 
            enclistObj.options.remove(i-1);
        }
        for (j = declistObj.options.length; j > 0; j --)
        { 
            declistObj.options.remove(j-1);
        }

        i = 0;
        j = 0;
		
        declistObj.options.add(new Option("all", j++));
        declistObj.setAttribute("title", "decoder");

        enclistObj.options.add(new Option("all", i++));
        enclistObj.setAttribute("title", "encoder");
    
    	for (var dev in ack.devinfo)
    	{
    		var device = ack.devinfo[dev];
    	
    	    // console.log(device.devaddr + " " + device.devtype + " " + sysmacSelectObj.options.length);
    		
    	    if (device.devtype == "decoder")
    	    {
    	    	declistObj.options.add(new Option(device.devaddr, j++));
                declistObj.setAttribute("title", device.devtype);
    	    }
    	    else if (device.devtype == "encoder")
    	    {
    	    	enclistObj.options.add(new Option(device.devaddr, i++));
                enclistObj.setAttribute("title", device.devtype);
    	    }
    	}

        //complete_message("Getting Devices Done!")
    }
    else if (ack && ack.ack && ack.ack.cmd)
    {
        if (ack.ack.cmd.indexOf("update data start") > -1)
        {
            if (ack.ack.status == "success")
            {
                send_file();
            }
            else
            {
                var info = ack.ack.cmd + " " + ack.ack.status;
                Console.log(info);
                alert(info)
            }
        }
        else if (ack.ack.cmd.indexOf("update data block") > -1)
        {
            if (ack.ack.status == "success")
            {
                uploadFileAck();    
            }

            return;
        }
        else if (ack.ack.cmd.indexOf("update data stop") > -1)
        {
            if (ack.ack.status != "success")
            {
                //if firmware
                if (curobj == "dec" || curobj == "enc")
                {
                    alert("Send file " + file.name + " failed, \n\nPlease try again!");
                }
                //else res
                else
                {
                    var msg  = "Send file " + file.name + " failed, \n\nResource file is not valid!\n\n";
                        msg += "Jpeg file's resolution must be 1920x1080!\n\n";
                        msg += "Jpeg file's size must be less than 2M bytes on disk!\n\n";
                        msg += "Please check again!";
                    alert(msg);
                }
            }
            else
            {
                if (curobj == "csv") {
                    alert("Send file " + file.name + " finished! \n\nPlease click Apply.");
                }
                else {
                    alert("Send file " + file.name + " finished! \n\nPlease click Update.");
                }

                //enable burning
                var burning_dec = document.getElementById("burning_dec");
                var burning_enc = document.getElementById("burning_enc");
                var burning_logo = document.getElementById("burning_logo");

                burning_dec.disabled = false;
                burning_enc.disabled = false;
                burning_logo.disabled = false;
            }

            return;
        }
        else if (ack.ack.cmd.indexOf("update firmware") > -1)
        {
            if (ack.ack.status != "success")
            {
                alert("Update firmware failed");
            }
            else
            {
                alert("Update firmware finished");
            }

            return;
        }
        else if (ack.ack.cmd.indexOf("update res") > -1)
        {
            if (ack.ack.status != "success")
            {
                alert("Update res failed");
            }
            else
            {
                alert("Update res finished");
            }

            return;
        }
        else if (ack.ack.cmd.indexOf("update csv") > -1)
        {
            if (ack.ack.status != "success")
            {
                alert("Apply csv failed");
            }
            else
            {
                alert("Apply csv finished");
            }

            return;
        }
        else if (ack.ack.cmd.indexOf("update get devices") > -1)
        {
            ; // 05222018 FangDa delete to let "searching device..." auto return     alert("Search Devices Done!");
        }		

        Console.log(ack.ack.cmd +" return "+ ack.ack.status);
    }
}

//Called when setup.html loaded
function initUpdateData()
{
    if(!ws)
    {
        setupSocket(); //websocket  
    }
 
    Update_buildControls();

    Console.log("Waiting devices info ...");
}

function setProcess(pos){
    if(curobj != "csv") {
        var obj = curobj;  
        var processbar = document.getElementById("processbar_" + obj);  

        processbar.innerHTML = pos + "%";  
        processbar.style.width = "100%";
    }
}

var reader = new FileReader();
var step = 700;
var total = 0;
var cuLoaded = 0;
var loaded = 0;
var startTime;

reader.onerror = function (e) {
    console.log("error!")
}

//after read one block
reader.onload = function (e) {
    //data loaded by reader
    loaded = e.loaded;

    if (loaded == 0)
    {
        alert("read file 0 bytes!");
    }
    //send to server side
    uploadFile(reader.result, cuLoaded, loaded);
}

//split file to block
function readBlob(start) {
    var blob = file.slice(start, start + step);

    reader.readAsArrayBuffer(blob);

    if (!reader.result) {
        //read failed, try again!
        reader.readAsArrayBuffer(blob);
    }
}

//send data to server
function uploadFile(result, startIndex, loaded) {

    if (ws)
    {
        var cmd = "update data block " + startIndex + "," + loaded + "|";
        var str = String.fromCharCode.apply(null, new Uint8Array(result));

        for (var i = 0; i < loaded; i ++) {
            var ch = str.charCodeAt(i).toString(16);
            if (ch.length == 1)
            {
                cmd += "0";
            }
            cmd += ch;
       }

       var loaded1 = parseInt(step) - parseInt(loaded);
       for (var i = 0; i < loaded1; i ++) {
           cmd += "00";
       }

        ws.doSend(cmd);
        //console.log(cmd);
    }
}

//call by handledata
function uploadFileAck () {
    //not finished, continue
    console.log("upload file " + parseInt(cuLoaded * 100 / total) + "% finished");
    if (total != 0) {
        setProcess(parseInt(cuLoaded * 100 / total));
    }                
    cuLoaded += loaded;

    if (cuLoaded < total) {
        //loading
        readBlob(cuLoaded);
    } else {
        //finished
        console.log('total ' + (new Date().getTime() - startTime.getTime()) / 1000);
        cuLoaded = total;
        if (total != 0) {
            setProcess(100);
        }                
        if (ws) {
            //100%
            var cmd = "update data stop ";
                cmd += file.name;
                cmd += ";";

            ws.doSend(cmd);
            console.log(cmd);
        }

        //enabled burn
        var inputElement_enc = document.getElementById("file_enc");
        var inputElement_dec = document.getElementById("file_dec");
        var inputElement_logo = document.getElementById("file_logo");

        inputElement_enc.disabled = false;
        inputElement_dec.disabled = false;
        inputElement_logo.disabled = false;
    }
}

function send_file() {

    setProcess(0);

    startTime = new Date();

    //send file
    readBlob(0);
}

//file.onchange is for file input
function file_onchange(obj) {
    //Get file object
    var inputElement = document.getElementById("file_" + obj);
    var fileList = inputElement.files;    
    
    file = fileList[0];
    total = file.size;
    cuLoaded = 0;
    curobj = obj;

    console.info("filesize:" + file.size);

    if (ws) {
        var cmd = "update data start " + file.name + ";";
        ws.doSend(cmd);
        console.log(cmd);
    }

    //disable burn
    var burning_dec = document.getElementById("burning_dec");
    var burning_enc = document.getElementById("burning_enc");
    var burning_logo = document.getElementById("burning_logo");

    burning_dec.disabled = true;
    burning_enc.disabled = true;
    burning_logo.disabled = true;
}

//start to burn file!
function file_burning(obj)
{
    var inputElement = document.getElementById("file_" + obj);
    var fileList = inputElement.files;    
    if(obj != "csv") {
        var devlist = document.getElementById("list_" + obj);
        //logo and dec use same devlist!!!
        if (obj == "logo")
            devlist = document.getElementById("list_dec");
    }
    var file = "";
    var size = 0;
    var ip = "";

    if(fileList[0])
    {
        file = fileList[0].name;
        size = fileList[0].size;
    }

    var host = document.location.host.split(":");
    var cmd  = "update set serverip ";
        cmd += host[0].length > 0 ? host[0] : "127.0.0.1";
        cmd += ";";

    if(obj != "csv") {		
        if (devlist.selectedIndex != -1)
        {
            ip = devlist.options[devlist.selectedIndex].text;
        }
        else
        {
            ip = "127.0.0.1";
        }
    }

    if (obj == "dec" || obj == "enc")
    {
        //dec or enc
        cmd += "update firmware " + ip + " with " + file + " filesize " + size + " type " + obj;
    }
    else if(obj == "logo")
    {
        //res file like logo etc
        cmd += "update res " + ip + " with " + file + " filesize " + size + " type dec";
    }
    else if(obj == "csv")
    {
        //csv file
        cmd += "update csv with " + file;
    }


    if (ws)
    {
        ws.doSend(cmd);

        console.log(cmd);
    }
}

function file_burning_enc()
{
    var inputElement = document.getElementById("file_enc");
    var fileList = inputElement.files;
    
    if (fileList[0] && fileList[0].name.length > 0) 
    {
        file_burning("enc");
    }
}

function file_burning_dec()
{
    var inputElement = document.getElementById("file_dec");
    var fileList = inputElement.files;
    
    if (fileList[0] && fileList[0].name.length > 0) 
    {
        file_burning("dec");
    }
}

function file_burning_logo()
{
    var inputElement = document.getElementById("file_logo");
    var fileList = inputElement.files;
    
    if (fileList[0] && fileList[0].name.length > 0) 
    {
        file_burning("logo");
    }
}

function file_burning_csv()
{
    var inputElement = document.getElementById("file_csv");
    var fileList = inputElement.files;
    
    if (fileList[0] && fileList[0].name.length > 0) 
    {
        file_burning("csv");
    }
}

function file_onchange_enc()
{
    //disable load dec file
    var inputElement = document.getElementById("file_enc");
    var fileList = inputElement.files;

    if (fileList[0].name.indexOf("TX_Update") == -1) {
        alert("Please select correct file to update (TX_Update_...)");
        return;
    }
	
    var inputElement_dec = document.getElementById("file_dec");
    var inputElement_logo = document.getElementById("file_logo");

    inputElement_dec.disabled = true;
    inputElement_logo.disabled = true;

    file_onchange("enc");
}

function file_onchange_dec()
{
    var inputElement = document.getElementById("file_dec");
    var fileList = inputElement.files;
    
    if (fileList[0].name.indexOf("RX_Update") == -1) {
        alert("Please select correct file to update (RX_Update_...)");
        return;
    }
    //disable load enc file
    var inputElement_enc = document.getElementById("file_enc");
    var inputElement_logo = document.getElementById("file_logo");

    inputElement_enc.disabled = true;
    inputElement_logo.disabled = true;
    
    file_onchange("dec");
}

function file_onchange_logo()
{
    var inputElement = document.getElementById("file_logo");
    var fileList = inputElement.files;    
    
    if (fileList[0].name.indexOf(".jpg") == -1) {
        alert("Please select correct file to update (*.jpg)");
        return;
    }
	
    //disable load enc file
    var inputElement_enc = document.getElementById("file_enc");
    var inputElement_dec = document.getElementById("file_dec");

    inputElement_enc.disabled = true;
    inputElement_dec.disabled = true;
    
    file_onchange("logo");    
}

function file_onchange_csv()
{
    var inputElement = document.getElementById("file_csv");
    var fileList = inputElement.files;    
    
    if (fileList[0].name.indexOf(".csv") == -1) {
        alert("Please select correct file to update (*.csv)");
        return;
    }
	
    //disable load enc file
    var inputElement_enc = document.getElementById("file_enc");
    var inputElement_dec = document.getElementById("file_dec");
    var inputElement_logo = document.getElementById("file_logo");	

    inputElement_enc.disabled = true;
    inputElement_dec.disabled = true;
    inputElement_logo.disabled = true;	
    
    file_onchange("csv");    
}

function update_updateDevices()
{
    if (ws)
    {
        showLoader("searching device...");
        var cmd = "update get devices;";
        ws.doSend(cmd);

        console.log(cmd);
        // Console.log(cmd);
    }
}

function Update_buildControls()
{
    var burning_dec = document.getElementById("burning_dec");
    var burning_enc = document.getElementById("burning_enc");
    var burning_logo = document.getElementById("burning_logo");

    burning_dec.disabled = true;
    burning_enc.disabled = true;
    burning_logo.disabled = true;

    curobj = "enc";
    setProcess(0);
    curobj = "dec";
    setProcess(0);
    curobj = "logo";
    setProcess(0);
}

function update_device_factory_default()
{
    //var ip = document.getElementById('ip4addripinfo');
    var hostip = document.location.host;

    if (hostip.length == 0) {
        hostip = "127.0.0.1";
    }

    var cmd = "config set device factory default";

    if (ws)
    {
        ws.doSend(cmd);
        console.log(cmd);
        //complete_message("Reset Factory Default Done!")        
    }    
}
